//*****************************************************************************
//
//  TextGridCtrl140.cpp
//
//*****************************************************************************

// MFCCWndNXhCTextGridCtrlNX`܂B
// CWnd
// CTextGridCtrl
// Microsoft Visual C++ 9.0 Standard EditionōĂ܂B
// ̃CúAGNU 򓙈ʌOp_(LGPL)ɊÂzz܂B


// This library is free software; you can redistribute it and/or 
// modify it under the terms of the GNU Lesser General Public 
// License as published by the Free Software Foundation; either 
// version 2.1 of the License, or (at your option) any later version. 

// This library is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
// Lesser General Public License for more details. 

// You should have received a copy of the GNU Lesser General Public 
// License along with this library; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 

#include <afxwin.h>
#include <afxext.h>
#include <afxdllx.h>
#include "TextGridCtrl140.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// MFC̊gDLLłB
// class AFX_EXT_CLASS CXXXX : public CXXX ...
// AFX_EXT_CLASS_AFXDLLy_AFXEXTvvZbTɒ`ꍇ
// MFC ɂ__declspec(dllexport)ƂĒ`B
// #inlcude <afxdllx.h>YʂƁB

extern "C"

static AFX_EXTENSION_MODULE TextGridCtrl140DLL = { NULL, NULL };

int APIENTRY
DllMain (HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved) {
	if (dwReason == DLL_PROCESS_ATTACH) {
		TRACE0 ("TEXTGRIDCTRL140.DLL B\n");
		// g DLL P񂾂܂B
		AfxInitExtensionModule (TextGridCtrl140DLL, hInstance);
		//  DLL \[X `FC֑}܂B
		new CDynLinkLibrary (TextGridCtrl140DLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH) {
		TRACE0 ("TEXTGRIDCTRL140.DLL IB\n");
	}
	return 1;   // OK
}

//*****************************************************************************
//
// CTextGridEditNX
//
//*****************************************************************************

// bZ[W}bv
IMPLEMENT_DYNCREATE (CTextGridEdit, CEdit)

BEGIN_MESSAGE_MAP (CTextGridEdit, CEdit)
	ON_WM_KILLFOCUS ()
	ON_WM_KEYDOWN ()
	ON_WM_CHAR ()
END_MESSAGE_MAP()

// RXgN^
CTextGridEdit::CTextGridEdit () {
}

// fXgN^
CTextGridEdit::~CTextGridEdit () {
}

// tH[JXꂽƂ
void CTextGridEdit::OnKillFocus (CWnd* pNewWnd) {
	_RPTF1 (_CRT_WARN, "CInplaceEditBox::OnKillFocus (pNewWnd=0x%08x)\n", pNewWnd);
	// ʂ̃_CAOt[EBhEɃtH[JXڈړƂA
	// ̃Rg[܂ސeEBhEɃtH[JXꂽƂʒmB
	CWnd* pParentWnd = GetParent ();
	if (pParentWnd != pNewWnd) {
		pParentWnd->SendMessage (WM_KILLFOCUS, (WPARAM)pNewWnd, (LPARAM)0L);
	}
	else {
		//pParentWnd->SetFocus ();
	}
	CEdit::OnKillFocus (pNewWnd); //20080809ǉ(Jbg̏h~)
}


// L[
void CTextGridEdit::OnKeyDown (UINT nChar, UINT nRepCnt, UINT nFlags) {
	
	CWnd* pParentWnd = GetParent ();
	switch (nChar) {
	case VK_UP:
	case VK_LEFT:
	case VK_RIGHT:
	case VK_DOWN:
		pParentWnd->SetFocus ();
		pParentWnd->PostMessage (WM_KEYDOWN, VK_RETURN, (nRepCnt << 16) | nFlags);
		pParentWnd->PostMessage (WM_KEYDOWN, nChar, (nRepCnt << 16) | nFlags);
		break;
	case VK_RETURN:
		pParentWnd->SetFocus ();	
		pParentWnd->PostMessage (WM_KEYDOWN, VK_RETURN, (nRepCnt << 16) | nFlags);
		break;
	case VK_ESCAPE:
		pParentWnd->SetFocus ();
		pParentWnd->PostMessage (WM_KEYDOWN, VK_ESCAPE, (nRepCnt << 16) | nFlags);
		break;
	}
	CWnd::OnKeyDown (nChar, nRepCnt, nFlags);
}

// ͎
void CTextGridEdit::OnChar (UINT nChar, UINT nRepCnt, UINT nFlags) {
	// EnterƂɃv[v[̂h
	switch (nChar) {
	case VK_RETURN:
		return;
	}
	CEdit::OnChar (nChar, nRepCnt, nFlags);
}

//*****************************************************************************
//
// CTextGridCtrlNX
//
//*****************************************************************************

#define TEXTGRIDCTRL_RANGE(A,B,C) ((A)>(B)?(A):((B)>(C)?(C):(B)))

#define IDC_TEXTBOX 3232

IMPLEMENT_DYNCREATE (CTextGridCtrl, CWnd)

BEGIN_MESSAGE_MAP (CTextGridCtrl, CWnd)
	ON_WM_CREATE ()
	ON_WM_DESTROY ()
	ON_WM_SIZE ()
	ON_WM_ENABLE ()
	ON_WM_SETFOCUS ()
	ON_WM_KILLFOCUS ()
	ON_WM_VSCROLL ()
	ON_WM_HSCROLL ()
	ON_WM_ERASEBKGND ()
	ON_WM_PAINT ()
	ON_WM_LBUTTONDOWN ()
	ON_WM_RBUTTONDOWN ()
	ON_WM_MOUSEMOVE ()
	ON_WM_LBUTTONUP ()
	ON_WM_LBUTTONDBLCLK ()
	ON_WM_KEYDOWN ()
	ON_WM_CHAR ()
	ON_MESSAGE (WM_IME_STARTCOMPOSITION, OnImeStartComposition)
	ON_COMMAND (IDM_CONTEXT_CUT, OnContextCut)
	ON_UPDATE_COMMAND_UI (IDM_CONTEXT_CUT, OnUpdateContextCut)
	ON_COMMAND (IDM_CONTEXT_COPY, OnContextCopy)
	ON_UPDATE_COMMAND_UI (IDM_CONTEXT_COPY, OnUpdateContextCopy)
	ON_COMMAND (IDM_CONTEXT_PASTE, OnContextPaste)
	ON_UPDATE_COMMAND_UI (IDM_CONTEXT_PASTE, OnUpdateContextPaste)
	ON_COMMAND (IDM_CONTEXT_DELETE, OnContextDelete)
	ON_UPDATE_COMMAND_UI (IDM_CONTEXT_DELETE, OnUpdateContextDelete)
END_MESSAGE_MAP ()

// RXgN^
CTextGridCtrl::CTextGridCtrl () {
	this->CTextGridCtrl::CTextGridCtrl (1, 1);
}

// sƗ񐔂w肵RXgN^
CTextGridCtrl::CTextGridCtrl (int nNumRows, int nNumCols) {
	ASSERT (1 <= nNumRows && nNumRows <= 1024);
	ASSERT (1 <= nNumCols && nNumCols <= 1024);
	m_nNumRows = nNumRows;
	m_nNumCols = nNumCols;
	m_theRowHeightArray.SetSize (m_nNumRows);
	m_theColWidthArray.SetSize (m_nNumCols);
	m_theRowTitleArray.SetSize (m_nNumRows);
	m_theColTitleArray.SetSize (m_nNumCols);
	m_theCellStringArray.SetSize (m_nNumRows * m_nNumCols);
	m_nCurRow = 0;
	m_nCurCol = 0;
	m_nVisibleTopRow = 0;
	m_nVisibleLeftCol = 0;
	m_nTitleWidth = 64;
	m_nTitleHeight = 18;
	m_nSelectedTopRow = 0;
	m_nSelectedBottomRow = 0;
	m_nSelectedLeftCol = 0;
	m_nSelectedRightCol = 0;
	m_nMouseMode = 0;
	m_nMouseDownRow = 0;
	m_nMouseDownCol = 0;
	m_nKeyMoveRow = 0;
	m_nKeyMoveCol = 0;
	m_bCut = FALSE;
	int i, j;
	for (i = 0; i < GetNumRows (); i++) {
		SetRowHeight (i, 18);
	}
	for (j = 0; j < GetNumCols (); j++) {
		SetColWidth (j, 64);
	}
}

// fXgN^
CTextGridCtrl::~CTextGridCtrl () {
	m_theRowHeightArray.RemoveAll ();
	m_theColWidthArray.RemoveAll ();
	m_theRowTitleArray.RemoveAll ();
	m_theColTitleArray.RemoveAll ();
	m_theCellStringArray.RemoveAll ();
}


// Iy[V

// s̐ݒ(̊֐͕pɂɎgׂł͂Ȃ)
BOOL CTextGridCtrl::SetNumRows (int nNumRows) {
	ASSERT (1 <= nNumRows && nNumRows <= 1024);
	if (nNumRows <= 1 || nNumRows > 1024) {
		return FALSE;
	}
	int nOldNumRows = m_nNumRows;
	int nOldNumCols = m_nNumCols;
	CUIntArray theOldRowHeightArray;
	CStringArray theOldRowTitleArray;
	CStringArray theOldCellStringArray;
	theOldRowHeightArray.Copy (m_theRowHeightArray);
	theOldRowTitleArray.Copy (m_theRowTitleArray);
	theOldCellStringArray.Copy (m_theCellStringArray);
	m_nNumRows = nNumRows;
	m_theRowHeightArray.SetSize (m_nNumRows);
	m_theRowTitleArray.SetSize (m_nNumRows);
	m_theCellStringArray.SetSize (m_nNumRows * m_nNumCols);
	int i, j;
	for (i = 0; i < m_nNumRows; i++) {
		if (i < nOldNumRows) {
			int nTemp = theOldRowHeightArray.GetAt (i);
			m_theRowHeightArray.SetAt (i, nTemp);
		}
	}
	for (i = 0; i < m_nNumRows; i++) {
		if (i < nOldNumRows) {
			CString strTemp = theOldRowTitleArray.GetAt (i);
			m_theRowTitleArray.SetAt (i, strTemp);
		}
	}
	for (i = 0; i < m_nNumRows; i++) {
		if (i < nOldNumRows) {
			for (j = 0; j < m_nNumCols; j++) {
				if (j < nOldNumCols) {
					CString strTemp = theOldCellStringArray.GetAt (i * nOldNumCols + j);
					m_theCellStringArray.SetAt (i * m_nNumCols + j, strTemp);
				}
			}
		}
	}
	SetScrollRange (SB_VERT, 0, m_nNumRows - 1, TRUE);
	return TRUE;
}

// 񐔂̐ݒ(̊֐͕pɂɎgׂł͂Ȃ)
BOOL CTextGridCtrl::SetNumCols (int nNumCols) {
	ASSERT (1 <= nNumCols && nNumCols <= 1024);
	if (nNumCols <= 1 || nNumCols > 1024) {
		return FALSE;
	}
	int nOldNumRows = m_nNumRows;
	int nOldNumCols = m_nNumCols;
	CUIntArray theOldColWidthArray;
	CStringArray theOldColTitleArray;
	CStringArray theOldCellStringArray;
	theOldColWidthArray.Copy (m_theColWidthArray);
	theOldColTitleArray.Copy (m_theColTitleArray);
	theOldCellStringArray.Copy (m_theCellStringArray);
	m_nNumCols = nNumCols;
	m_theColWidthArray.SetSize (m_nNumCols);
	m_theColTitleArray.SetSize (m_nNumCols);
	m_theCellStringArray.SetSize (m_nNumRows * m_nNumCols);
	int i, j;
	for (j = 0; j < m_nNumCols; j++) {
		if (j < nOldNumCols) {
			int nTemp = theOldColWidthArray.GetAt (j);
			m_theColWidthArray.SetAt (j, nTemp);
		}
	}
	for (j = 0; j < m_nNumCols; j++) {
		if (j < nOldNumCols) {
			CString strTemp = theOldColTitleArray.GetAt (j);
			m_theColTitleArray.SetAt (j, strTemp);
		}
	}
	for (i = 0; i < m_nNumRows; i++) {
		if (i < nOldNumRows) {
			for (j = 0; j < m_nNumCols; j++) {
				if (j < nOldNumCols) {
					CString strTemp = theOldCellStringArray.GetAt (i * nOldNumCols + j);
					m_theCellStringArray.SetAt (i * m_nNumCols + j, strTemp);
				}
			}
		}
	}
	SetScrollRange (SB_HORZ, 0, m_nNumCols - 1, TRUE);
	return TRUE;
}

// ^Cgs̍̐ݒ
BOOL CTextGridCtrl::SetTitleHeight (int nHeight) {
	ASSERT (0 <= nHeight && nHeight <= 1024);
	if (nHeight <= 0 || nHeight > 1024) {
		return FALSE;
	}
	m_nTitleHeight = nHeight;
	return TRUE;
}

// ^Cg̐̕ݒ
BOOL CTextGridCtrl::SetTitleWidth (int nWidth) {
	ASSERT (0 <= nWidth && nWidth <= 1024);
	if (nWidth <= 0 || nWidth > 1024) {
		return FALSE;
	}
	m_nTitleWidth = nWidth;
	return TRUE;
}

// s̎擾
int CTextGridCtrl::GetRowHeight (int nRow) const {
	ASSERT (0 <= nRow && nRow < m_nNumRows);
	if (nRow < 0 || nRow >= m_nNumRows) {
		return 0;
	}
	return (int)(m_theRowHeightArray.GetAt (nRow));
}

// 񕝂̎擾
int CTextGridCtrl::GetColWidth (int nCol) const {
	ASSERT (0 <= nCol && nCol < m_nNumCols);
	if (nCol < 0 || nCol >= m_nNumCols) {
		return 0;
	}
	return (int)(m_theColWidthArray.GetAt (nCol));
}


// s̐ݒ
BOOL CTextGridCtrl::SetRowHeight (int nRow, int nHeight) {
	ASSERT (0 <= nRow && nRow < m_nNumRows);
	ASSERT (0 < nHeight && nHeight <= 1024);
	if (nRow < 0 || nRow >= m_nNumRows) {
		return FALSE;
	}
	if (nHeight <= 0 || nHeight > 1024) {
		return FALSE;
	}
	m_theRowHeightArray.SetAt (nRow, nHeight);
	if (m_hWnd) {
		if (GetParent () != NULL) {
			GetParent ()->SendMessage
				(WM_COMMAND, (TGN_ROWHEIGHTCHANGE << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
		}
	}
	return TRUE;
}

// 񕝂̐ݒ
BOOL CTextGridCtrl::SetColWidth (int nCol, int nWidth) {
	ASSERT (0 <= nCol && nCol < m_nNumCols);
	ASSERT (0 < nWidth && nWidth <= 1024);
	m_theColWidthArray.SetAt (nCol, nWidth);
	if (nCol < 0 || nCol >= m_nNumCols) {
		return FALSE;
	}
	if (nWidth <= 0 || nWidth > 1024) {
		return FALSE;
	}
	if (m_hWnd) {
		if (GetParent () != NULL) {
			GetParent ()->SendMessage
				(WM_COMMAND, (TGN_COLWIDTHCHANGE << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
		}
	}
	return TRUE;
}

// Zv̎擾
int CTextGridCtrl::GetCellSumHeight () const {
	int nHeight = 0;
	for (int i = 0; i < m_nNumRows; i++) {
		nHeight += GetRowHeight (i);
	}
	return nHeight;
}

// Zv̎擾
int CTextGridCtrl::GetCellSumWidth () const {
	int nWidth = 0;
	for (int j = 0; j < m_nNumCols; j++) {
		nWidth += GetColWidth (j);
	}
	return nWidth;
}
	
// s^Cg̎擾
CString CTextGridCtrl::GetRowTitle (int nRow) const {
	ASSERT (0 <= nRow && nRow < m_nNumRows);
	if (nRow < 0 || nRow >= m_nNumRows) {
		return _T("");
	}
	return m_theRowTitleArray.GetAt (nRow);	
}

// ^Cg̎擾
CString CTextGridCtrl::GetColTitle (int nCol) const {
	ASSERT (0 <= nCol && nCol < m_nNumCols);
	if (nCol < 0 || nCol >= m_nNumCols) {
		return _T("");
	}
	return m_theColTitleArray.GetAt (nCol);	
}

// Obh̎擾
CString CTextGridCtrl::GetCellString (int nRow, int nCol) const {
	ASSERT (0 <= nRow && nRow < m_nNumRows);
	ASSERT (0 <= nCol && nCol < m_nNumCols);
	if (nRow < 0 || nRow >= m_nNumRows) {
		return _T("");
	}
	if (nCol < 0 || nCol >= m_nNumCols) {
		return _T("");
	}
	return m_theCellStringArray.GetAt (nRow * m_nNumCols + nCol);	
}

// s^Cg̐ݒ
BOOL CTextGridCtrl::SetRowTitle (int nRow, CString strRowTitle) {
	ASSERT (0 <= nRow && nRow < m_nNumRows);
	if (nRow < 0 || nRow >= m_nNumRows) {
		return FALSE;
	}
	m_theRowTitleArray.SetAt (nRow, strRowTitle);	
	if (m_hWnd) {
		if (GetParent () != NULL) {
			GetParent ()->SendMessage
				(WM_COMMAND, (TGN_ROWTITLECHANGE << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
		}
	}
	return TRUE;
}

// ^Cg̐ݒ
BOOL CTextGridCtrl::SetColTitle (int nCol, CString strColTitle) {
	ASSERT (0 <= nCol && nCol < m_nNumCols);
	if (nCol < 0 || nCol >= m_nNumCols) {
		return FALSE;
	}
	m_theColTitleArray.SetAt (nCol, strColTitle);	
	if (m_hWnd) {
		if (GetParent () != NULL) {
			GetParent ()->SendMessage
				(WM_COMMAND, (TGN_COLTITLECHANGE << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
		}
	}
	return TRUE;
}

// Obh̐ݒ
BOOL CTextGridCtrl::SetCellString (int nRow, int nCol, CString strGridString) {
	ASSERT (0 <= nRow && nRow < m_nNumRows);
	ASSERT (0 <= nCol && nCol < m_nNumCols);
	if (nRow < 0 || nRow >= m_nNumRows) {
		return FALSE;
	}
	if (nCol < 0 || nCol >= m_nNumCols) {
		return FALSE;
	}
	m_theCellStringArray.SetAt (nRow * m_nNumCols + nCol, strGridString);	
	if (m_hWnd) {
		if (GetParent () != NULL) {
			GetParent ()->SendMessage
				(WM_COMMAND, (TGN_CELLSTRINGCHANGE << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
		}
	}
	return TRUE;
}

// ׂĂ̍s^Cg([)폜
void CTextGridCtrl::DeleteAllRowTitle () {
	for (int i = 0; i < m_nNumRows; i++) {
		m_theRowTitleArray.SetAt (i, _T(""));
	}
	if (m_hWnd) {
		if (GetParent () != NULL) {
			GetParent ()->SendMessage
				(WM_COMMAND, (TGN_ROWTITLECHANGE << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
		}
	}
}

// ׂĂ̗^Cg([)폜
void CTextGridCtrl::DeleteAllColTitle () {
	for (int j = 0; j < m_nNumCols; j++) {
		m_theColTitleArray.SetAt (j, _T(""));
	}
	if (m_hWnd) {
		if (GetParent () != NULL) {
			GetParent ()->SendMessage
				(WM_COMMAND, (TGN_COLTITLECHANGE << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
		}
	}
}

// ׂẴZ폜
void CTextGridCtrl::DeleteAllCellString () {
	for (int i = 0; i < m_nNumRows; i++) {
		for (int j = 0; j < m_nNumCols; j++) {
			m_theCellStringArray.SetAt (i * m_nNumCols + j, _T(""));
		}
	}
	if (m_hWnd) {
		if (GetParent () != NULL) {
			GetParent ()->SendMessage
				(WM_COMMAND, (TGN_CELLSTRINGCHANGE << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
		}
	}
}



// s̑}
BOOL CTextGridCtrl::InsertRow (int nRow) {
	return FALSE;
}

// ̑}
BOOL CTextGridCtrl::InsertCol (int nCol) {
	return FALSE;
}

// s̍폜
BOOL CTextGridCtrl::RemoveRow (int nRow) {
	return FALSE;
}

// ̍폜
BOOL CTextGridCtrl::RemoveCol (int nCol) {
	return FALSE;
}

// [ɕ\sԍ擾B
int CTextGridCtrl::GetVisibleBottomRow (long lLogPixelsX, long lLogPixelsY) const {
	CRect rcClient;
	GetClientRect (&rcClient);
	int nSumY = m_nTitleHeight * lLogPixelsY / 96;
	int i;
	for (i = m_nVisibleTopRow; i < m_nNumRows; i++) {
		nSumY += GetRowHeight (i) * lLogPixelsY / 96;
		if (nSumY > rcClient.Height ()) {
			break;
		}
	}
	return i;
}

// E[ɕ\sԍ擾B
int CTextGridCtrl::GetVisibleRightCol (long lLogPixelsX, long lLogPixelsY) const {
	CRect rcClient;
	GetClientRect (&rcClient);
	int nSumX = m_nTitleWidth * lLogPixelsX / 96;
	int j;
	for (j = m_nVisibleLeftCol; j < m_nNumCols; j++) {
		nSumX += GetColWidth (j) * lLogPixelsX / 96;
		if (nSumX > rcClient.Width ()) {
			break;
		}
	}
	return j;
}

// [ɕ\sԍݒ肷(EBhEƂ̂)
BOOL CTextGridCtrl::SetVisibleTopRow (int nVisibleTopRow, long lLogPixelsX, long lLogPixelsY) {
	ASSERT (0 <= nVisibleTopRow && nVisibleTopRow < m_nNumRows);
	ASSERT (m_hWnd);
	if (nVisibleTopRow < 0 || nVisibleTopRow >= m_nNumRows) {
		return FALSE;
	}
	if (m_hWnd == NULL) {
		return FALSE;
	}
	if (m_nVisibleTopRow != nVisibleTopRow) {
		m_nVisibleTopRow = nVisibleTopRow;
		SetScrollPos (SB_VERT, m_nVisibleTopRow, TRUE);
		if (GetParent () != NULL) {
			GetParent ()->SendMessage
				(WM_COMMAND, (TGN_VSCROLL << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
		}
	}
	return TRUE;
}

// [ɕ\ԍݒ肷(EBhEƂ̂)
BOOL CTextGridCtrl::SetVisibleLeftCol (int nVisibleLeftCol, long lLogPixelsX, long lLogPixelsY) {
	ASSERT (0 <= nVisibleLeftCol && nVisibleLeftCol < m_nNumCols);
	ASSERT (m_hWnd);
	if (nVisibleLeftCol < 0 || nVisibleLeftCol >= m_nNumCols) {
		return FALSE;
	}
	if (m_hWnd == NULL) {
		return FALSE;
	}
	if (m_nVisibleLeftCol != nVisibleLeftCol) {
		m_nVisibleLeftCol = nVisibleLeftCol;
		SetScrollPos (SB_HORZ, m_nVisibleLeftCol, TRUE);
		if (GetParent () != NULL) {
			GetParent ()->SendMessage
				(WM_COMMAND, (TGN_HSCROLL << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
		}
	}
	return TRUE;
}

// [ɕ\sԍݒ肷(EBhEƂ̂)
BOOL CTextGridCtrl::SetVisibleBottomRow (int nVisibleBottomRow, long lLogPixelsX, long lLogPixelsY) {
	ASSERT (0 <= nVisibleBottomRow && nVisibleBottomRow < m_nNumRows);
	ASSERT (m_hWnd);
	if (nVisibleBottomRow < 0 || nVisibleBottomRow >= m_nNumRows) {
		return FALSE;
	}
	if (m_hWnd == NULL) {
		return FALSE;
	}
	CRect rcClient;
	GetClientRect (&rcClient);
	if (GetRowHeight (nVisibleBottomRow) + m_nTitleHeight > rcClient.Height ()) {
		VERIFY (SetVisibleTopRow (nVisibleBottomRow, lLogPixelsX, lLogPixelsY));
	}
	else {
		int nSumY = m_nTitleHeight * lLogPixelsY / 96;
		int i;
		for (i = nVisibleBottomRow; i >= 0; i--) {
			nSumY += GetRowHeight (TEXTGRIDCTRL_RANGE (0, i, m_nNumRows - 1)) * lLogPixelsY / 96;
			if (nSumY > rcClient.Height ()) {
				break;
			}
		}
		VERIFY (SetVisibleTopRow (TEXTGRIDCTRL_RANGE (0, i + 1, m_nNumRows - 1), lLogPixelsX, lLogPixelsY));
	}
	return TRUE;
}

// E[ɕ\ԍݒ肷(EBhEƂ̂)
BOOL CTextGridCtrl::SetVisibleRightCol (int nVisibleRightCol, long lLogPixelsX, long lLogPixelsY) {
	ASSERT (0 <= nVisibleRightCol && nVisibleRightCol < m_nNumCols);
	ASSERT (m_hWnd);
	if (nVisibleRightCol < 0 || nVisibleRightCol >= m_nNumCols) {
		return FALSE;
	}
	if (m_hWnd == NULL) {
		return FALSE;
	}
	CRect rcClient;
	GetClientRect (&rcClient);
	if (GetColWidth (nVisibleRightCol) + m_nTitleWidth > rcClient.Width ()) {
		VERIFY (SetVisibleLeftCol (nVisibleRightCol, lLogPixelsX, lLogPixelsY));
	}
	else {
		int nSumX = m_nTitleWidth * lLogPixelsX / 96;
		int j;
		for (j = nVisibleRightCol; j >= 0; j--) {
			nSumX += GetColWidth (TEXTGRIDCTRL_RANGE (0, j, m_nNumCols - 1)) * lLogPixelsX / 96;
			if (nSumX > rcClient.Width ()) {
				break;
			}
		}
		VERIFY (SetVisibleLeftCol (TEXTGRIDCTRL_RANGE (0, j + 1, m_nNumCols - 1), lLogPixelsX, lLogPixelsY));
	}
	return TRUE;
}



// I͈͊֌W

// I͈͂̎擾
BOOL CTextGridCtrl::GetSelectedArea (int* pRow1, int* pRow2, int* pCol1, int* pCol2) {
	ASSERT (pRow1);
	ASSERT (pRow2);
	ASSERT (pCol1);
	ASSERT (pCol2);
	*pRow1 = m_nSelectedTopRow;
	*pRow2 = m_nSelectedBottomRow;
	*pCol1 = m_nSelectedLeftCol;
	*pCol2 = m_nSelectedRightCol;
	return TRUE;
}


// P̃ZI
BOOL CTextGridCtrl::SelectCell (int nRow, int nCol) {
	ASSERT (0 <= nRow && nRow < m_nNumRows);
	ASSERT (0 <= nCol && nCol < m_nNumCols);
	if (nRow < 0 || nRow >= m_nNumRows) {
		return FALSE;
	}
	if (nCol < 0 || nCol >= m_nNumCols) {
		return FALSE;
	}
	if (m_nSelectedTopRow != nRow ||
		m_nSelectedBottomRow != nRow ||
		m_nSelectedLeftCol != nCol ||
		m_nSelectedRightCol != nCol) {
		m_nSelectedTopRow = nRow;
		m_nSelectedBottomRow = nRow;
		m_nSelectedLeftCol = nCol;
		m_nSelectedRightCol = nCol;
		if (m_hWnd) {
			if (GetParent () != NULL) {
				GetParent ()->SendMessage
					(WM_COMMAND, (TGN_SELECTCHANGE << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
			}
		}
	}
	return TRUE;
}

// w͈͂I
BOOL CTextGridCtrl::SelectArea (int nRow1, int nRow2, int nCol1, int nCol2) {
	ASSERT (0 <= nRow1 && nRow1 < m_nNumRows);
	ASSERT (0 <= nRow2 && nRow2 < m_nNumRows);
	ASSERT (0 <= nCol1 && nCol1 < m_nNumCols);
	ASSERT (0 <= nCol2 && nCol2 < m_nNumCols);
	if (nRow1 < 0 || nRow1 >= m_nNumRows) {
		return FALSE;
	}
	if (nRow2 < 0 || nRow2 >= m_nNumRows) {
		return FALSE;
	}
	if (nCol1 < 0 || nCol1 >= m_nNumCols) {
		return FALSE;
	}
	if (nCol2 < 0 || nCol2 >= m_nNumCols) {
		return FALSE;
	}
	if (m_nSelectedTopRow != __min (nRow1, nRow2) ||
		m_nSelectedBottomRow != __max (nRow1, nRow2) ||
		m_nSelectedLeftCol != __min (nCol1, nCol2) ||
		m_nSelectedRightCol != __max (nCol1, nCol2)) {
		m_nSelectedTopRow = __min (nRow1, nRow2);
		m_nSelectedBottomRow = __max (nRow1, nRow2);
		m_nSelectedLeftCol = __min (nCol1, nCol2);
		m_nSelectedRightCol = __max (nCol1, nCol2);
		if (m_hWnd) {
			if (GetParent () != NULL) {
				GetParent ()->SendMessage
					(WM_COMMAND, (TGN_SELECTCHANGE << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
			}
		}
	}
	return TRUE;
}

// sŜI(nRow1=JnsAnRow2=IsAs)
BOOL CTextGridCtrl::SelectRow (int nRow1, int nRow2) {
	ASSERT (0 <= nRow1 && nRow1 < m_nNumRows);
	ASSERT (0 <= nRow2 && nRow2 < m_nNumRows);
	if (nRow1 < 0 || nRow1 >= m_nNumRows) {
		return FALSE;
	}
	if (nRow2 < 0 || nRow2 >= m_nNumRows) {
		return FALSE;
	}
	if (m_nSelectedTopRow != __min (nRow1, nRow2) ||
		m_nSelectedBottomRow != __max (nRow1, nRow2) ||
		m_nSelectedLeftCol != 0 || 
		m_nSelectedRightCol != m_nNumCols - 1) {
		m_nSelectedTopRow = __min (nRow1, nRow2);
		m_nSelectedBottomRow = __max (nRow1, nRow2);
		m_nSelectedLeftCol = 0;
		m_nSelectedRightCol = m_nNumCols - 1;
		if (m_hWnd) {
			if (GetParent () != NULL) {
				GetParent ()->SendMessage
					(WM_COMMAND, (TGN_SELECTCHANGE << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
			}
		}
	}
	return TRUE;
}

// ŜI(nCol1=JnAnCol2=IAs)
BOOL CTextGridCtrl::SelectCol (int nCol1, int nCol2) {
	ASSERT (0 <= nCol1 && nCol1 < m_nNumCols);
	ASSERT (0 <= nCol2 && nCol2 < m_nNumCols);
	if (nCol1 < 0 || nCol1 >= m_nNumCols) {
		return FALSE;
	}
	if (nCol2 < 0 || nCol2 >= m_nNumCols) {
		return FALSE;
	}
	if (m_nSelectedTopRow != 0 || 
		m_nSelectedBottomRow != m_nNumRows -1 ||
		m_nSelectedLeftCol != __min (nCol1, nCol2) || 
		m_nSelectedRightCol != __max (nCol1, nCol2)) {
		m_nSelectedTopRow = 0;
		m_nSelectedBottomRow = m_nNumRows - 1;
		m_nSelectedLeftCol = __min (nCol1, nCol2);
		m_nSelectedRightCol = __max (nCol1, nCol2);
		if (m_hWnd) {
			if (GetParent () != NULL) {
				GetParent ()->SendMessage
					(WM_COMMAND, (TGN_SELECTCHANGE << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
			}
		}
	}
	return TRUE;
}

// \ŜI
BOOL CTextGridCtrl::SelectAll () {
	if (m_nSelectedTopRow != 0 || 
		m_nSelectedBottomRow != m_nNumRows -1 ||
		m_nSelectedLeftCol != 0 || 
		m_nSelectedRightCol != m_nNumCols -1) {
		m_nSelectedTopRow = 0;
		m_nSelectedBottomRow = m_nNumRows - 1;
		m_nSelectedLeftCol = 0;
		m_nSelectedRightCol = m_nNumCols - 1;
		if (m_hWnd) {
			if (GetParent () != NULL) {
				GetParent ()->SendMessage
					(WM_COMMAND, (TGN_SELECTCHANGE << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
			}
		}
	}
	return TRUE;
}

// wZIĂ邩ǂׂB
BOOL CTextGridCtrl::IsSelectedCell (int nRow, int nCol) const {
	ASSERT (0 <= nRow && nRow < m_nNumRows);
	ASSERT (0 <= nCol && nCol < m_nNumCols);
	if (m_nSelectedTopRow <= nRow && nRow <= m_nSelectedBottomRow &&
		m_nSelectedLeftCol <= nCol && nCol <= m_nSelectedRightCol) {
		return TRUE;
	}
	return FALSE;
}

// sŜIĂ邩ǂׂB
BOOL CTextGridCtrl::IsSelectedRow (int nRow) const {
	ASSERT (0 <= nRow && nRow < m_nNumRows);
	if (m_nSelectedTopRow <= nRow && nRow <= m_nSelectedBottomRow &&
		m_nSelectedLeftCol == 0 && m_nSelectedRightCol == m_nNumCols - 1) {
		return TRUE;
	}
	return FALSE;
}

// ŜIĂ邩ǂׂB
BOOL CTextGridCtrl::IsSelectedCol (int nCol) const {
	ASSERT (0 <= nCol && nCol < m_nNumCols);
	if (m_nSelectedTopRow == 0 && m_nSelectedBottomRow == m_nNumRows - 1 &&
		m_nSelectedLeftCol <= nCol && nCol <= m_nSelectedRightCol) {
		return TRUE;
	}
	return FALSE;
}

// \ŜIĂ邩ǂׂB
BOOL CTextGridCtrl::IsSelectedAll () const {
	if (m_nSelectedTopRow == 0 && m_nSelectedBottomRow == m_nNumRows - 1 &&
		m_nSelectedLeftCol == 0 && m_nSelectedRightCol == m_nNumCols - 1) {
		return TRUE;
	}
	return FALSE;
}

// JgZ̐ݒ(Iy[Vp)
BOOL CTextGridCtrl::SetCurCell (int nRow, int nCol) {
	// ʂdpi擾
	HDC hDC = ::GetDC (this->GetSafeHwnd ());
	long lLogPixelsX = ::GetDeviceCaps (hDC, LOGPIXELSX);
	long lLogPixelsY = ::GetDeviceCaps (hDC, LOGPIXELSY);
	::ReleaseDC (this->GetSafeHwnd (), hDC);
	return SetCurCell (nRow, nCol, lLogPixelsX, lLogPixelsY);
}

// JgZ̐ݒ(Ăяop)
BOOL CTextGridCtrl::SetCurCell (int nRow, int nCol, long lLogPixelsX, long lLogPixelsY) {
	ASSERT (0 <= nRow && nRow < m_nNumRows);
	ASSERT (0 <= nCol && nCol < m_nNumCols);
	if (nRow < 0 || nRow >= m_nNumRows) {
		return FALSE;
	}
	if (nCol < 0 || nCol >= m_nNumCols) {
		return FALSE;
	}
	m_nCurRow = nRow;
	m_nCurCol = nCol;
	m_nKeyMoveRow = nRow;
	m_nKeyMoveCol = nCol;
	if (m_hWnd) {
		AutoScrolltoShowCell (m_nCurRow, m_nCurCol, lLogPixelsX, lLogPixelsY);
		MoveTextBox (lLogPixelsX, lLogPixelsY);
		if (GetParent () != NULL) {
			GetParent ()->SendMessage
				(WM_COMMAND, (TGN_CURCELLCHANGE << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
		}
	}
	return TRUE;
}

// wZNCAg̈悩͂ݏoĂꍇ̎XN[
BOOL CTextGridCtrl::AutoScrolltoShowCell (int nRow, int nCol, long lLogPixelsX, long lLogPixelsY) {
	ASSERT (0 <= nRow && nRow < m_nNumRows);
	ASSERT (0 <= nCol && nCol < m_nNumCols);
	ASSERT (m_hWnd);
	if (nRow < 0 || nRow >= m_nNumRows) {
		return FALSE;
	}
	if (nCol < 0 || nCol >= m_nNumCols) {
		return FALSE;
	}
	if (m_hWnd == NULL) {
		return FALSE;
	}
	VERIFY (AutoScrolltoShowRow (nRow, lLogPixelsX, lLogPixelsY));
	VERIFY (AutoScrolltoShowCol (nCol, lLogPixelsX, lLogPixelsY));
	return TRUE;
}

// wsNCAg̈悩͂ݏoꍇ̎XN[
BOOL CTextGridCtrl::AutoScrolltoShowRow (int nRow, long lLogPixelsX, long lLogPixelsY) {
	ASSERT (0 <= nRow && nRow < m_nNumRows);
	ASSERT (m_hWnd);
	if (nRow < 0 || nRow >= m_nNumRows) {
		return FALSE;
	}
	if (m_hWnd == NULL) {
		return FALSE;
	}
	CRect rcClient;
	GetClientRect (&rcClient);
	// Zr[̏ɂ͂ݏoꍇ̏
	if (nRow < m_nVisibleTopRow) {
		VERIFY (SetVisibleTopRow (nRow, lLogPixelsX, lLogPixelsY));
	}
	// Zr[̉ɂ͂ݏoꍇ̏
	else if (nRow >= GetVisibleBottomRow (lLogPixelsX, lLogPixelsY)) {
		VERIFY (SetVisibleBottomRow (nRow, lLogPixelsX, lLogPixelsY));
	}
	return TRUE;
}

// w񂪃NCAg̈悩͂ݏoꍇ̎XN[
BOOL CTextGridCtrl::AutoScrolltoShowCol (int nCol, long lLogPixelsX, long lLogPixelsY) {
	ASSERT (0 <= nCol && nCol < m_nNumCols);
	ASSERT (m_hWnd);
	if (nCol < 0 || nCol >= m_nNumCols) {
		return FALSE;
	}
	if (m_hWnd == NULL) {
		return FALSE;
	}
	CRect rcClient;
	GetClientRect (&rcClient);
	// Zr[̍ɂ͂ݏoꍇ̏
	if (nCol < m_nVisibleLeftCol) {
		VERIFY (SetVisibleLeftCol (nCol, lLogPixelsX, lLogPixelsY));
	}
	// Zr[̉Eɂ͂ݏoꍇ̏
	else if (nCol >= GetVisibleRightCol (lLogPixelsX, lLogPixelsY)) {
		VERIFY (SetVisibleRightCol (nCol, lLogPixelsX, lLogPixelsY));
	}
	return TRUE;
}


// EBhEԊ֐

// ǂݎpԂ擾
BOOL CTextGridCtrl::IsReadOnly () const {
	return (GetStyle () & TGS_READONLY) == 0 ? FALSE : TRUE;
}

// ǂݎpԂݒ肷
BOOL CTextGridCtrl::SetReadOnly (BOOL bReadOnly) {
	VERIFY (m_theGridPen.DeleteObject ());
	VERIFY (m_theWindowBackBrush.DeleteObject ());
	if (bReadOnly || IsWindowEnabled () == FALSE) {
		VERIFY (m_theGridPen.CreatePen (PS_SOLID, 1, GetSysColor (COLOR_APPWORKSPACE)));
		VERIFY (m_theWindowBackBrush.CreateSolidBrush (GetSysColor (COLOR_BTNFACE)));
	}
	else {
		VERIFY (m_theGridPen.CreatePen (PS_SOLID, 1, GetSysColor (COLOR_BTNFACE)));
		VERIFY (m_theWindowBackBrush.CreateSolidBrush (GetSysColor (COLOR_WINDOW)));
	}
	if (bReadOnly) {
		return ModifyStyle (0, TGS_READONLY);
	}
	else {
		return ModifyStyle (TGS_READONLY, 0);
	}
}

// s̍ŒԂ擾
BOOL CTextGridCtrl::IsRowHeightFixed () const {
	return (GetStyle () & TGS_ROWHEIGHTFIXED) == 0 ? FALSE : TRUE;
}

// s̍ŒԂݒ肷
BOOL CTextGridCtrl::SetRowHeightFixed (BOOL bRowHeightFixed) {
	if (bRowHeightFixed) {
		return ModifyStyle (0, TGS_ROWHEIGHTFIXED);
	}
	else {
		return ModifyStyle (TGS_ROWHEIGHTFIXED, 0);
	}
}

// ̕ŒԂ擾
BOOL CTextGridCtrl::IsColWidthFixed () const {
	return (GetStyle () & TGS_COLWIDTHFIXED) == 0 ? FALSE : TRUE;
}

// ̕ŒԂݒ肷
BOOL CTextGridCtrl::SetColWidthFixed (BOOL bColWidthFixed) {
	if (bColWidthFixed) {
		return ModifyStyle (0, TGS_COLWIDTHFIXED);
	}
	else {
		return ModifyStyle (TGS_COLWIDTHFIXED, 0);
	}
}

// XN[o[֌W

// XN[o[̒
BOOL CTextGridCtrl::AdjustVScrollBar () {
	SCROLLINFO si;
	si.fMask = SIF_PAGE | SIF_RANGE;
	si.nMin = 0;
	si.nMax = m_nNumRows - 1;
	si.nPage = TEXTGRIDCTRL_RANGE (0, 1, m_nNumRows - 1);
	VERIFY (SetScrollInfo (SB_VERT, &si, TRUE));
	return TRUE;
}

// XN[o[̒
BOOL CTextGridCtrl::AdjustHScrollBar () {
	SCROLLINFO si;
	si.fMask = SIF_PAGE | SIF_RANGE;
	si.nMin = 0;
	si.nMax = m_nNumCols - 1;
	si.nPage = TEXTGRIDCTRL_RANGE (0, 1, m_nNumCols - 1);
	VERIFY (SetScrollInfo (SB_HORZ, &si, TRUE));
	return TRUE;
}

// Wϊ֌W

// wW̍sԍƗԍ߂B
// *pRow==-1̓^CgsA0<=*pRow<m_nNumRow͍sԍA*pRow==m_nNumRow͉󗓁B
// *pCol==-1̓^CgA0<=*pCol<m_nNumCol͗ԍA*pCol==m_nNumCol͉E󗓁B
BOOL CTextGridCtrl::PointToCell (CPoint point, int* pRow, int* pCol, long lLogPixelsX, long lLogPixelsY) const {
	// s
	int i, j;
	int y = m_nTitleHeight * lLogPixelsY / 96;
	if (point.y < y) {
		*pRow = -1;
	}
	else {
		for (i = m_nVisibleTopRow; i < m_nNumRows; i++) {
			if (y <= point.y && point.y < y + GetRowHeight (i) * lLogPixelsY / 96) {
				break;
			}
			y += GetRowHeight (i) * lLogPixelsY / 96;
		}
		*pRow = i;
	}
	// 
	int x = m_nTitleWidth * lLogPixelsX / 96;
	if (point.x < x) {
		*pCol = -1;
	}
	else {
		for (j = m_nVisibleLeftCol; j < m_nNumCols; j++) {
			if (x <= point.x && point.x < x + GetColWidth (j) * lLogPixelsX / 96) {
				break;
			}
			x += GetColWidth (j) * lLogPixelsX / 96;
		}
		*pCol = j;
	}
	return TRUE;
}

// wW̍sEԍƗ񋫊Eԍ߂(Z̉E̐yщ̐EƂ)B
// *pRowBorder==-1͋EɂȂA-1<=*pRowBorder<m_nNumRow͍sEԍB
// *pColBorder==-1͋EɂȂA-1<=*pColBorder<m_nNumCol͗񋫊EԍB
BOOL CTextGridCtrl::PointToBorder (CPoint point, int* pRowBorder, int* pColBorder, long lLogPixelsX, long lLogPixelsY) const {
	// s
	*pRowBorder = -1;
	int y = m_nTitleHeight * lLogPixelsY / 96;
	for (int i = m_nVisibleTopRow; i < m_nNumRows; i++) {
		y += GetRowHeight (i) * lLogPixelsY / 96;
		if (y - 2 <= point.y && point.y <= y + 2) {
			*pRowBorder = i;
			break;
		}
	}
	// 
	*pColBorder = -1;
	int x = m_nTitleWidth * lLogPixelsX / 96;
	for (int j = m_nVisibleLeftCol; j < m_nNumCols; j++) {
		x += GetColWidth (j) * lLogPixelsX / 96;
		if (x - 2 <= point.x && point.x <= x + 2) {
			*pColBorder = j;
			break;
		}
	}
	return TRUE;
}


// ws̐L`W߂Bʏ̂ǂLĂȂꍇFALSEԂB
BOOL CTextGridCtrl::CellToRect (int nRow, int nCol, CRect* pRect, long lLogPixelsX, long lLogPixelsY) const {
	BOOL bRet = TRUE;
	int i, j;
	// s
	int nVisibleBottomRow = GetVisibleBottomRow (lLogPixelsX, lLogPixelsY);
	if (nRow < 0) {
		(*pRect).top = 0;	
		(*pRect).bottom = m_nTitleHeight * lLogPixelsY / 96;
	}
	else if (0 <= nRow && nRow < m_nVisibleTopRow || nRow > nVisibleBottomRow) {
		(*pRect).top = 0;	
		(*pRect).bottom = 0;
		bRet = FALSE;
	}
	else {
		int y = m_nTitleHeight;
		for (i = m_nVisibleTopRow; i < nRow; i++) {
			y += GetRowHeight (i) * lLogPixelsY / 96;
		}
		(*pRect).top = y;
		(*pRect).bottom = y + GetRowHeight (i) * lLogPixelsY / 96;
	}
	// 
	int nVisibleRightCol = GetVisibleRightCol (lLogPixelsX, lLogPixelsY);
	if (nCol < 0) {
		(*pRect).left = 0;
		(*pRect).right = m_nTitleWidth * lLogPixelsX / 96;
	}
	else if (0 <= nCol && nCol < m_nVisibleLeftCol || nCol > nVisibleRightCol) {
		(*pRect).left = 0;
		(*pRect).right = 0;
		bRet = FALSE;
	}
	else {
		int x = m_nTitleWidth * lLogPixelsX / 96;
		for (j = m_nVisibleLeftCol; j < nCol; j++) {
			x += GetColWidth (j) * lLogPixelsX / 96;
		}
		(*pRect).left = x;
		(*pRect).right = x + GetColWidth (j) * lLogPixelsX / 96;
	}
	return bRet;
}


// eLXg{bNX

// ݃eLXg{bNXŕҏWǂԂB
BOOL CTextGridCtrl::IsTextEditing () const {
	ASSERT (m_theTextBox.m_hWnd != NULL);
	if (m_theTextBox.m_hWnd == NULL) {
		return FALSE;
	}
	return (m_theTextBox.GetStyle () & WS_VISIBLE) ? TRUE : FALSE;
}

// eLXg{bNXł̕ҏWJnB
BOOL CTextGridCtrl::BeginTextEditing () {
	ASSERT (m_theTextBox.m_hWnd != NULL);
	if (m_theTextBox.m_hWnd == NULL) {
		return FALSE;
	}
	m_theTextBox.SetWindowText (CString (""));
	m_theTextBox.EmptyUndoBuffer ();
	m_theTextBox.ShowWindow (SW_SHOW);
	m_theTextBox.SetFocus ();
	m_theTextBox.UpdateWindow ();
	return TRUE;
}

// eLXg{bNXł̕ҏWpJnB
BOOL CTextGridCtrl::BeginTextEditingContinue () {
	ASSERT (m_theTextBox.m_hWnd != NULL);
	if (m_theTextBox.m_hWnd == NULL) {
		return FALSE;
	}
	CString strTemp;
	strTemp = GetCellString (m_nCurRow, m_nCurCol);
	m_theTextBox.SetWindowText (strTemp);
	m_theTextBox.SetSel (strTemp.GetLength (), strTemp.GetLength (), TRUE);
	m_theTextBox.EmptyUndoBuffer ();
	m_theTextBox.ShowWindow (SW_SHOW);
	m_theTextBox.SetFocus ();
	m_theTextBox.UpdateWindow ();
	return TRUE;
}

// eLXg{bNXł̕ҏWIAVli[B
BOOL CTextGridCtrl::EndTextEditingOK () {
	ASSERT (m_theTextBox.m_hWnd != NULL);
	if (m_theTextBox.m_hWnd == NULL) {
		return FALSE;
	}
	// ݂̃Z̕ҏWeLXg擾
	CString strBuf;
	m_theTextBox.GetWindowText (strBuf);
	// l̔f
	int nRow = GetCurRow ();
	int nCol = GetCurCol ();
	SetCellString (nRow, nCol, strBuf);
	// ҏWI	
	m_theTextBox.ShowWindow (SW_HIDE);
	this->SetFocus ();
	return TRUE;
}

// eLXg{bNXł̕ҏWIAVli[ȂB
BOOL CTextGridCtrl::EndTextEditingCancel () {
	ASSERT (m_theTextBox.m_hWnd != NULL);
	if (m_theTextBox.m_hWnd == NULL) {
		return FALSE;
	}
	m_theTextBox.ShowWindow (SW_HIDE);
	this->SetFocus ();
	return TRUE;
}

// eLXg{bNẌړ(VISIBLE==FALSE܂)
BOOL CTextGridCtrl::MoveTextBox (long lLogPixelsX, long lLogPixelsY) {
	ASSERT (m_theTextBox.m_hWnd != NULL);
	if (m_theTextBox.m_hWnd == NULL) {
		return FALSE;
	}
	CRect rcCurCell;
	this->CellToRect (m_nCurRow, m_nCurCol, &rcCurCell, lLogPixelsX, lLogPixelsY);
	m_theTextBox.MoveWindow 
		(rcCurCell.left, rcCurCell.top + rcCurCell.Height () / 2 - 6, 
		rcCurCell.Width (), 13);
	return TRUE;
}


// ҏW

// ؂
BOOL CTextGridCtrl::Cut () {
	m_bCut = TRUE;
	if (Copy () == FALSE) {
		m_bCut = FALSE;
		return FALSE;
	}
	if (Delete () == FALSE) {
		m_bCut = FALSE;
		return FALSE;
	}
	if (m_hWnd) {
		if (GetParent () != NULL) {
			GetParent ()->SendMessage
				(WM_COMMAND, (TGN_CELLSTRINGCHANGE << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
			GetParent ()->SendMessage
				(WM_COMMAND, (TGN_CUT << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
		}
	}
	m_bCut = FALSE;
	return TRUE;
}

// Rs[
BOOL CTextGridCtrl::Copy () {
	// ]p쐬
	CString strTextCopy;
	for (int i = m_nSelectedTopRow; i <= m_nSelectedBottomRow; i++) {
		CString strTextLine;
		for (int j = m_nSelectedLeftCol; j <= m_nSelectedRightCol; j++) {
			strTextLine += GetCellString (i, j);
			if (j == m_nSelectedRightCol) {
				strTextLine += _T("\r\n");
			}
			else {
				strTextLine += _T("\t");
			}
		}
		strTextCopy += strTextLine;
	}
	// Nbv{[h]
	TCHAR* p = NULL;
	HGLOBAL hGlobalMem = NULL;
	if ((hGlobalMem = GlobalAlloc(GHND, (strTextCopy.GetLength() + 1)  * sizeof (TCHAR))) == NULL) {
		_RPT0 (_CRT_WARN, "۰؊mەs\B͎߰s܂B");
		return FALSE;
	}
	if ((p = (TCHAR*)GlobalLock(hGlobalMem)) == NULL) {
		_RPT0 (_CRT_WARN, "۰،Œs\B͎߰s܂B");
		GlobalFree (hGlobalMem);
		return FALSE;
	}
	_tcsncpy (p, (LPCTSTR)strTextCopy, strTextCopy.GetLength ());
	if (GlobalUnlock (hGlobalMem) == TRUE) {
		//܂ۯĂTRUE,ꂽorװFALSEB
		_RPT0 (_CRT_WARN, "۰،ŒُB͎߰s܂B");
		GlobalFree (hGlobalMem);
		return FALSE;
	}
	if (::OpenClipboard (AfxGetMainWnd()->m_hWnd) == FALSE) {
		_RPT0 (_CRT_WARN, "دް޵ݕs\B͎߰s܂B");
		GlobalFree (hGlobalMem);
		return FALSE;
	}
	if (::EmptyClipboard() == FALSE) {
		::CloseClipboard();//ɕȂ޲۸ޕ\ɂB
		_RPT0 (_CRT_WARN, "دްޏs\B͎߰s܂B");
		GlobalFree (hGlobalMem);
		return FALSE;
	}
	if (::SetClipboardData (CF_UNICODETEXT, hGlobalMem) == FALSE) {
		::CloseClipboard ();
		_RPT0 (_CRT_WARN, "دްޓ]s\B͎߰s܂B");
		GlobalFree (hGlobalMem);
		return FALSE;
	}
	CloseClipboard ();
	//hGlobalMem͂͂₱۸т̂̂ł͂ȂB
	//]āAGlobalFree(hGlobalMem)ȂB
	if (m_hWnd) {
		if (GetParent () != NULL && m_bCut == FALSE) {
			GetParent ()->SendMessage
				(WM_COMMAND, (TGN_COPY << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
		}
	}
	return TRUE;

}

// \t
BOOL CTextGridCtrl::Paste () {
	// ʂdpi擾
	HDC hDC = ::GetDC (this->GetSafeHwnd ());
	long lLogPixelsX = ::GetDeviceCaps (hDC, LOGPIXELSX);
	long lLogPixelsY = ::GetDeviceCaps (hDC, LOGPIXELSY);
	::ReleaseDC (this->GetSafeHwnd (), hDC);

	// Nbv{[hf[^]
	if (IsClipboardFormatAvailable(CF_UNICODETEXT) == FALSE) {
		_RPT0 (_CRT_WARN, "دްނLȌ`ł͂܂B\tɎs܂B");
		return FALSE;
	}
	if (::OpenClipboard(AfxGetMainWnd()->m_hWnd) == FALSE) {
		_RPT0 (_CRT_WARN, "دްނJ܂B\tɎs܂B");
		return FALSE;
	}
	HGLOBAL hData = NULL;
	if ((hData = GetClipboardData(CF_UNICODETEXT)) == NULL) {
		CloseClipboard ();//ɕȂ޲۸ޕ\ɂB
		_RPT0 (_CRT_WARN, "دްނ]s\B\tɎs܂B");
		return FALSE;
	}
	TCHAR* p = NULL;//]ޯ̧B
	if ((p = (TCHAR*)GlobalLock(hData)) == NULL) {
		CloseClipboard();
		_RPT0 (_CRT_WARN, "۰،Œs\B\tɎs܂B");
		return FALSE;
	}
	CString strTextPaste (p);
	if ((GlobalUnlock(hData)) == TRUE) {
		//܂ۯĂTRUE,ꂽorװFALSEB
		CloseClipboard();
		_RPT0 (_CRT_WARN, "۰،Œُ(vI)B\tɎs܂B");
		//return FALSE;
	}
	//dvIvO~OWindows95(AXL[) P.929@Ɉȉ̂悤ɋLqB
	//wدްނ۰ނOްۯۯ͂Bx
	if (::CloseClipboard() == FALSE) {
		_RPT0 (_CRT_WARN, "دްނ܂B𑱂܂B");
	}
	// ̃y[Xg
	if (strTextPaste == _T("")) {
		_RPT0 (_CRT_WARN, "\t镶񂪂܂B\tɎs܂B");
		return FALSE;
	}
	int i = m_nSelectedTopRow;
	int j = m_nSelectedLeftCol;
	int jMax = 0;
	CString strTextLine;
	CString strTextCell;
	while (1) {
		j = m_nSelectedLeftCol;
		int nn = strTextPaste.Find (_T("\r\n"));
		if (nn < 0) {
			strTextLine = strTextPaste;
			if (strTextLine == _T("")) {
				i--;
				break;
			}
			strTextPaste = _T ("");
		}
		else {
			strTextLine = strTextPaste.Left (nn);
			strTextPaste = strTextPaste.Mid (nn + 2);	
		}
		while (1) {
			int nt = strTextLine.Find (_T("\t"));
			if (nt < 0) {
				strTextCell = strTextLine;
				strTextLine = _T("");
			}
			else {
				strTextCell = strTextLine.Left (nt);
				strTextLine = strTextLine.Mid (nt + 1);
			}
			if (0 <= i && i <= m_nNumRows - 1 && 0 <= j && j <= m_nNumCols - 1) {
				m_theCellStringArray.SetAt (i * m_nNumCols + j, strTextCell);
			}
			if (j > jMax) {
				jMax = j;
			}
			if (nt < 0) {
				break;
			}
			j++;
		}
		if (nn < 0) {
			break;
		}
		i++;
	}
	SetCurCell (m_nSelectedTopRow, m_nSelectedLeftCol, lLogPixelsX, lLogPixelsY);
	SelectArea (m_nSelectedTopRow, TEXTGRIDCTRL_RANGE (0, i, m_nNumRows - 1),
		m_nSelectedLeftCol, TEXTGRIDCTRL_RANGE (0, jMax, m_nNumCols - 1));
	if (m_hWnd) {
		if (GetParent () != NULL) {
			GetParent ()->SendMessage
				(WM_COMMAND, (TGN_CELLSTRINGCHANGE << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
			GetParent ()->SendMessage
				(WM_COMMAND, (TGN_PASTE << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
		}
	}
	return TRUE;
}

// 폜
BOOL CTextGridCtrl::Delete () {
	for (int i = m_nSelectedTopRow; i <= m_nSelectedBottomRow; i++) {
		for (int j = m_nSelectedLeftCol; j <= m_nSelectedRightCol; j++) {
			m_theCellStringArray.SetAt (i * m_nNumCols + j, _T(""));
		}
	}
	if (m_hWnd) {
		if (GetParent () != NULL && m_bCut == FALSE) {
			GetParent ()->SendMessage
				(WM_COMMAND, (TGN_CELLSTRINGCHANGE << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
			GetParent ()->SendMessage
				(WM_COMMAND, (TGN_DELETE << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
		}
	}
	return TRUE;
}


// ^uL[_EȊÕbZ[W̃I[o[Ch
BOOL CTextGridCtrl::PreTranslateMessage (MSG* msg) {
	if (msg->message == WM_KEYDOWN && msg->wParam == VK_TAB) {
		return CWnd::PreTranslateMessage (msg);
	}
	::TranslateMessage (msg);
	::DispatchMessage (msg);
	return TRUE;
}

// bZ[W}bv

// EBhE쐬
int CTextGridCtrl::OnCreate (LPCREATESTRUCT lpCreateStruct) {
	// ʂdpi擾
	HDC hDC = ::GetDC (this->GetSafeHwnd ());
	long lLogPixelsX = ::GetDeviceCaps (hDC, LOGPIXELSX);
	long lLogPixelsY = ::GetDeviceCaps (hDC, LOGPIXELSY);
	::ReleaseDC (this->GetSafeHwnd (), hDC);

	// Obh`p̃yݒ
	if (IsReadOnly () == TRUE || IsWindowEnabled () == FALSE) {
		VERIFY (m_theGridPen.CreatePen (PS_SOLID, 1, GetSysColor (COLOR_APPWORKSPACE)));
		VERIFY (m_theWindowBackBrush.CreateSolidBrush (GetSysColor (COLOR_BTNFACE)));
	}
	else {
		VERIFY (m_theGridPen.CreatePen (PS_SOLID, 1, GetSysColor (COLOR_BTNFACE)));
		VERIFY (m_theWindowBackBrush.CreateSolidBrush (GetSysColor (COLOR_WINDOW)));
	}
	VERIFY (m_theCurCellPen.CreatePen (PS_SOLID, 3, RGB (0, 0, 0)));
	// eLXg`p̃tHgݒ
	LOGFONT lf;
	CFont* pFont = CFont::FromHandle 
		((HFONT)(::GetStockObject (DEFAULT_GUI_FONT)));
	pFont->GetLogFont (&lf);
	VERIFY (m_theTextFont.CreateFontIndirect (&lf));
	//VERIFY (m_theTextFont.CreateFont (12, 0, 0, 0, FW_THIN, FALSE, FALSE, FALSE,
	//	DEFAULT_CHARSET, OUT_CHARACTER_PRECIS, CLIP_CHARACTER_PRECIS, DEFAULT_QUALITY,
	//	DEFAULT_PITCH, "lr oSVbN"));
	// eLXg{bNX̐
	VERIFY (m_theTextBox.Create (WS_CHILD | ES_AUTOHSCROLL, 
		CRect (0, 0, 0, 0), this, IDC_TEXTBOX));
	m_theTextBox.SetFont (&m_theTextFont);
	m_theTextBox.ShowWindow (SW_HIDE);
	MoveTextBox (lLogPixelsX, lLogPixelsY);
	// ReLXgj[̍쐬
	m_theContextMenu.CreatePopupMenu ();
	m_theContextMenu.AppendMenu (MF_STRING, IDM_CONTEXT_CUT, _T("؂(&T)"));
	m_theContextMenu.AppendMenu (MF_STRING, IDM_CONTEXT_COPY, _T("Rs[(&C)"));
	m_theContextMenu.AppendMenu (MF_STRING, IDM_CONTEXT_PASTE, _T("\t(&P)"));
	m_theContextMenu.AppendMenu (MF_STRING, IDM_CONTEXT_DELETE, _T("폜(&D)"));
	return CWnd::OnCreate (lpCreateStruct);
}

// EBhEj
void CTextGridCtrl::OnDestroy () {
	if (m_theTextBox.m_hWnd) {
		if (IsTextEditing ()) {
			EndTextEditingOK ();
		}
	}
	VERIFY (m_theGridPen.DeleteObject ());
	VERIFY (m_theCurCellPen.DeleteObject ());
	VERIFY (m_theWindowBackBrush.DeleteObject ());
	VERIFY (m_theTextFont.DeleteObject ());
	VERIFY (m_theTextBox.DestroyWindow ());
	VERIFY (m_theContextMenu.DestroyMenu ());
	CWnd::OnDestroy ();
}

// EBhETCYύX
void CTextGridCtrl::OnSize (UINT nType, int cx, int cy) {
	this->AdjustVScrollBar ();
	this->AdjustHScrollBar ();
	CWnd::OnSize (nType, cx, cy);
}

// Cl[uύXꂽ
void CTextGridCtrl::OnEnable (BOOL bEnable) {
	m_theGridPen.DeleteObject ();
	m_theWindowBackBrush.DeleteObject ();
	if (IsReadOnly () == TRUE || bEnable == FALSE) {
		VERIFY (m_theGridPen.CreatePen (PS_SOLID, 1, GetSysColor (COLOR_APPWORKSPACE)));
		VERIFY (m_theWindowBackBrush.CreateSolidBrush (GetSysColor (COLOR_BTNFACE)));
	}
	else {
		VERIFY (m_theGridPen.CreatePen (PS_SOLID, 1, GetSysColor (COLOR_BTNFACE)));
		VERIFY (m_theWindowBackBrush.CreateSolidBrush (GetSysColor (COLOR_WINDOW)));
	}
	CWnd::OnEnable (bEnable);
}

// tH[JX󂯎Ƃ
void CTextGridCtrl::OnSetFocus (CWnd* pOldWnd) {
	if (GetParent () != NULL && pOldWnd != &m_theTextBox) {
		GetParent ()->SendMessage
			(WM_COMMAND, (TGN_SETFOCUS << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
	}
	CWnd::OnSetFocus (pOldWnd);
}

// tH[JXƂ
void CTextGridCtrl::OnKillFocus (CWnd* pNewWnd) {
	if (m_theTextBox.m_hWnd) {
		if (IsTextEditing () && pNewWnd != &m_theTextBox) {
			EndTextEditingOK ();
		}
	}
	if (GetParent () != NULL && pNewWnd != &m_theTextBox) {
		GetParent ()->SendMessage
			(WM_COMMAND, (TGN_KILLFOCUS << 16) | GetDlgCtrlID (), (INT_PTR)(this->m_hWnd));
	}
	CWnd::OnKillFocus (pNewWnd);
}

// XN[
void CTextGridCtrl::OnVScroll (UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) {
	// ʂdpi擾
	HDC hDC = ::GetDC (this->GetSafeHwnd ());
	long lLogPixelsX = ::GetDeviceCaps (hDC, LOGPIXELSX);
	long lLogPixelsY = ::GetDeviceCaps (hDC, LOGPIXELSY);
	::ReleaseDC (this->GetSafeHwnd (), hDC);

	if (IsTextEditing ()) {
		EndTextEditingOK ();
	}
	switch (nSBCode) {
	case SB_LINEUP:
		SetVisibleTopRow
			(TEXTGRIDCTRL_RANGE (0, GetVisibleTopRow () - 1, m_nNumRows - 1), lLogPixelsX, lLogPixelsY);
		break;
	case SB_LINEDOWN:
		SetVisibleTopRow
			(TEXTGRIDCTRL_RANGE (0, GetVisibleTopRow () + 1, m_nNumRows - 1), lLogPixelsX, lLogPixelsY);
		break;
	case SB_PAGEUP:
		SetVisibleBottomRow
			(TEXTGRIDCTRL_RANGE (0, GetVisibleTopRow (), m_nNumRows - 1), lLogPixelsX, lLogPixelsY);
		break;
	case SB_PAGEDOWN:
		SetVisibleTopRow
			(TEXTGRIDCTRL_RANGE (0, GetVisibleBottomRow (lLogPixelsX, lLogPixelsY), m_nNumRows - 1), lLogPixelsX, lLogPixelsY);
		break;
	case SB_THUMBPOSITION:
	case SB_THUMBTRACK:
		SetVisibleTopRow
			(TEXTGRIDCTRL_RANGE (0, (int)nPos, m_nNumRows - 1), lLogPixelsX, lLogPixelsY);
		break;
	}
	MoveTextBox (lLogPixelsX, lLogPixelsY);
	Invalidate ();
}

// XN[
void CTextGridCtrl::OnHScroll (UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) {
	// ʂdpi擾
	HDC hDC = ::GetDC (this->GetSafeHwnd ());
	long lLogPixelsX = ::GetDeviceCaps (hDC, LOGPIXELSX);
	long lLogPixelsY = ::GetDeviceCaps (hDC, LOGPIXELSY);
	::ReleaseDC (this->GetSafeHwnd (), hDC);

	if (IsTextEditing ()) {
		EndTextEditingOK ();
	}
	switch (nSBCode) {
	case SB_LINELEFT:
		SetVisibleLeftCol
			(TEXTGRIDCTRL_RANGE (0, GetVisibleLeftCol () - 1, m_nNumCols - 1), lLogPixelsX, lLogPixelsY);
		break;
	case SB_LINERIGHT:
		SetVisibleLeftCol
			(TEXTGRIDCTRL_RANGE (0, GetVisibleLeftCol () + 1, m_nNumCols - 1), lLogPixelsX, lLogPixelsY);
		break;
	case SB_PAGELEFT:
		SetVisibleRightCol
			(TEXTGRIDCTRL_RANGE (0, GetVisibleLeftCol (), m_nNumCols - 1), lLogPixelsX, lLogPixelsY);
		break;
	case SB_PAGERIGHT:
		SetVisibleLeftCol
			(TEXTGRIDCTRL_RANGE (0, GetVisibleRightCol (lLogPixelsX, lLogPixelsY), m_nNumCols - 1), lLogPixelsX, lLogPixelsY);
		break;
	case SB_THUMBPOSITION:
	case SB_THUMBTRACK:
		SetVisibleLeftCol
			(TEXTGRIDCTRL_RANGE (0, (int)nPos, m_nNumCols - 1), lLogPixelsX, lLogPixelsY);
		break;
	}
	MoveTextBox (lLogPixelsX, lLogPixelsY);
	Invalidate ();
}

// wȉ 
BOOL CTextGridCtrl::OnEraseBkgnd (CDC* pDC) {
	CRect rcClient;
	GetClientRect (&rcClient);

	// ʂdpi擾
	HDC hDC = ::GetDC (this->GetSafeHwnd ());
	long lLogPixelsX = ::GetDeviceCaps (hDC, LOGPIXELSX);
	long lLogPixelsY = ::GetDeviceCaps (hDC, LOGPIXELSY);
	::ReleaseDC (this->GetSafeHwnd (), hDC);


	int nGridHeight = 0;
	for (int i = m_nVisibleTopRow; i < m_nNumRows; i++) {
		nGridHeight += GetRowHeight (i) * lLogPixelsY / 96;
	}
	int nGridWidth = 0;
	for (int j = m_nVisibleLeftCol; j < m_nNumCols; j++) {
		nGridWidth += GetColWidth (j) * lLogPixelsX / 96;
	}
	// Eɗ]
	if (m_nTitleWidth + nGridWidth < rcClient.right) {
		CRect rcFillRect (rcClient);
		rcFillRect.left = m_nTitleWidth * lLogPixelsX / 96 + nGridWidth;
		pDC->FillSolidRect (rcFillRect, GetSysColor (COLOR_APPWORKSPACE));
	}
	// ɗ]
	if (m_nTitleHeight + nGridHeight < rcClient.bottom) {
		CRect rcFillRect (rcClient);
		rcFillRect.top = m_nTitleHeight * lLogPixelsY / 96 + nGridHeight;
		pDC->FillSolidRect (rcFillRect, GetSysColor (COLOR_APPWORKSPACE));
	}
	return TRUE;
}

// EBhE`掞
void CTextGridCtrl::OnPaint () {
	// ʂdpi擾
	HDC hDC = ::GetDC (this->GetSafeHwnd ());
	long lLogPixelsX = ::GetDeviceCaps (hDC, LOGPIXELSX);
	long lLogPixelsY = ::GetDeviceCaps (hDC, LOGPIXELSY);
	::ReleaseDC (this->GetSafeHwnd (), hDC);

	CPaintDC dc (this);
	int nVisibleRightCol = TEXTGRIDCTRL_RANGE (0, GetVisibleRightCol (lLogPixelsX, lLogPixelsY), m_nNumCols - 1);
	int nVisibleBottomRow = TEXTGRIDCTRL_RANGE (0, GetVisibleBottomRow (lLogPixelsX, lLogPixelsY), m_nNumRows - 1);

	int i, j;
	int nGridHeight = 0;
	for (i = m_nVisibleTopRow; i <= nVisibleBottomRow; i++) {
		nGridHeight += GetRowHeight (i) * lLogPixelsY / 96;
	}
	int nGridWidth = 0;
	for (j = m_nVisibleLeftCol; j <= nVisibleRightCol; j++) {
		nGridWidth += GetColWidth (j) * lLogPixelsX / 96;
	}

	dc.SetBkMode (TRANSPARENT);
	CFont* pOldFont = dc.SelectObject (&m_theTextFont);
	CBrush* pOldBrush = dc.SelectObject (&m_theWindowBackBrush);
	if (IsWindowEnabled () == FALSE) {
		dc.SetTextColor (GetSysColor (COLOR_GRAYTEXT));
	}
	else {
		dc.SetTextColor (GetSysColor (COLOR_WINDOWTEXT));
	}
	int x, y;
	// ^Cg̕`
	dc.FillSolidRect (0, 0, m_nTitleWidth * lLogPixelsX / 96, m_nTitleHeight * lLogPixelsY / 96,
		GetSysColor (COLOR_BTNFACE));
	dc.Draw3dRect (0, 0, m_nTitleWidth * lLogPixelsX / 96, m_nTitleHeight * lLogPixelsY / 96, 
		GetSysColor (COLOR_BTNHIGHLIGHT), GetSysColor (COLOR_BTNSHADOW));
	if (IsSelectedAll ()) {
		dc.PatBlt (0, 0, m_nTitleWidth * lLogPixelsX / 96, m_nTitleHeight * lLogPixelsY / 96, DSTINVERT);
	}
	// ^Cg̕`
	x = m_nTitleWidth * lLogPixelsX / 96;
	for (j = m_nVisibleLeftCol; j <= nVisibleRightCol; j++) {
		dc.FillSolidRect (x, 0, GetColWidth (j) * lLogPixelsX / 96, m_nTitleHeight * lLogPixelsY / 96,
			GetSysColor (COLOR_BTNFACE));
		dc.Draw3dRect (x, 0, GetColWidth (j) * lLogPixelsX / 96, m_nTitleHeight * lLogPixelsY / 96,
			GetSysColor (COLOR_BTNHIGHLIGHT), GetSysColor (COLOR_BTNSHADOW));
		dc.DrawText (GetColTitle (j), CRect (x, 0, x + GetColWidth (j) * lLogPixelsX / 96, m_nTitleHeight * lLogPixelsY / 96),
			DT_LEFT | DT_VCENTER | DT_SINGLELINE);
		if (IsSelectedCol (j)) {
			dc.PatBlt (x, 0, GetColWidth (j) * lLogPixelsX / 96, m_nTitleHeight * lLogPixelsY / 96, DSTINVERT);
		}
		x += GetColWidth (j) * lLogPixelsX / 96;
	}
	// ^Cg̕`
	y = m_nTitleHeight * lLogPixelsY / 96;
	for (i = m_nVisibleTopRow; i <= nVisibleBottomRow; i++) {
		dc.FillSolidRect (0, y, m_nTitleWidth * lLogPixelsX / 96, GetRowHeight (i) * lLogPixelsY / 96,
			GetSysColor (COLOR_BTNFACE));
		dc.Draw3dRect (0, y, m_nTitleWidth * lLogPixelsX / 96, GetRowHeight (i) * lLogPixelsY / 96, 
			GetSysColor (COLOR_BTNHIGHLIGHT), GetSysColor (COLOR_BTNSHADOW));
		dc.DrawText (GetRowTitle (i), CRect (0, y, m_nTitleWidth * lLogPixelsX / 96, y + GetRowHeight (i) * lLogPixelsY / 96),
			DT_LEFT | DT_VCENTER | DT_SINGLELINE);
		if (IsSelectedRow (i)) {
			dc.PatBlt (0, y, m_nTitleWidth * lLogPixelsX / 96, GetRowHeight (i) * lLogPixelsY / 96, DSTINVERT);
		}
		y += GetRowHeight (i) * lLogPixelsY / 96;
	}

	// ObhGA̔
	if (IsReadOnly () == TRUE || IsWindowEnabled () == FALSE) {
		dc.FillSolidRect (m_nTitleWidth * lLogPixelsX / 96, m_nTitleHeight * lLogPixelsY / 96, nGridWidth, nGridHeight, 
			GetSysColor (COLOR_BTNFACE));
	}
	else {
		dc.FillSolidRect (m_nTitleWidth * lLogPixelsX / 96, m_nTitleHeight * lLogPixelsY / 96, nGridWidth, nGridHeight, 
			GetSysColor (COLOR_WINDOW));
	}
	// Obh̕`
	CPen* pOldPen = dc.SelectObject (&m_theGridPen);
	y = 0;
	for (i = m_nVisibleTopRow; i <= nVisibleBottomRow; i++) {
		y += GetRowHeight (i) * lLogPixelsY / 96;
		dc.MoveTo (m_nTitleWidth * lLogPixelsX / 96, m_nTitleHeight * lLogPixelsY / 96 + y - 1);
		dc.LineTo (m_nTitleWidth * lLogPixelsX / 96 + nGridWidth, m_nTitleHeight * lLogPixelsY / 96 + y - 1);
	}
	// cObh̕`
	x = 0;
	for (j = m_nVisibleLeftCol; j <= nVisibleRightCol; j++) {
		x += GetColWidth (j) * lLogPixelsX / 96;
		dc.MoveTo (m_nTitleWidth * lLogPixelsX / 96 + x - 1, m_nTitleHeight * lLogPixelsY / 96);
		dc.LineTo (m_nTitleWidth * lLogPixelsX / 96 + x - 1, m_nTitleHeight * lLogPixelsY / 96 + nGridHeight);
	}
	dc.SelectObject (pOldPen);
	// JgZ̘g`
	if (m_nVisibleTopRow <= m_nCurRow && m_nCurRow <= nVisibleBottomRow &&
		m_nVisibleLeftCol <= m_nCurCol && m_nCurCol <= nVisibleRightCol) {
		y = m_nTitleHeight * lLogPixelsY / 96;
		for (i = m_nVisibleTopRow; i < m_nCurRow; i++) {
			y += GetRowHeight (i) * lLogPixelsY / 96;
		}
		x = m_nTitleWidth * lLogPixelsX / 96;
		for (j = m_nVisibleLeftCol; j < m_nCurCol; j++) {
			x += GetColWidth (j) * lLogPixelsX / 96;
		}
		pOldPen = dc.SelectObject (&m_theCurCellPen);
		dc.Rectangle (x, y, x + GetColWidth (j) * lLogPixelsX / 96, y + GetRowHeight (i) * lLogPixelsY / 96);
		dc.SelectObject (pOldPen);
	}
	// eZ̕̕`
	y = m_nTitleHeight * lLogPixelsY / 96;
	for (i = m_nVisibleTopRow; i <= nVisibleBottomRow; i++) {
		x = m_nTitleWidth * lLogPixelsX / 96;
		for (j = m_nVisibleLeftCol; j <= nVisibleRightCol; j++) {
			dc.DrawText (GetCellString (i, j), 
				CRect (x, y, x + GetColWidth (j) * lLogPixelsX / 96, y + GetRowHeight (i) * lLogPixelsY / 96),
				DT_LEFT | DT_VCENTER | DT_SINGLELINE);
			if (IsSelectedCell (i, j) && (m_nCurRow != i || m_nCurCol != j)) {
				dc.PatBlt (x, y, GetColWidth (j) * lLogPixelsX / 96, GetRowHeight (i) * lLogPixelsY / 96, DSTINVERT);
			}
			x += GetColWidth (j) * lLogPixelsX / 96;
		}
		y += GetRowHeight (i) * lLogPixelsY / 96;
	}

	dc.SelectObject (pOldFont);
	dc.SelectObject (pOldBrush);
}

#define TEXTGRIDCTRL_MOUSEMODENONE 0
#define TEXTGRIDCTRL_MOUSEMODECELLSELECT 1
#define TEXTGRIDCTRL_MOUSEMODEROWSELECT 2
#define TEXTGRIDCTRL_MOUSEMODECOLSELECT 3
#define TEXTGRIDCTRL_MOUSEMODEROWHEIGHTCHANGE 4
#define TEXTGRIDCTRL_MOUSEMODECOLWIDTHCHANGE 5


// }EX{^
void CTextGridCtrl::OnLButtonDown (UINT nFlags, CPoint point) {
	this->SetFocus ();

	// ʂdpi擾
	HDC hDC = ::GetDC (this->GetSafeHwnd ());
	long lLogPixelsX = ::GetDeviceCaps (hDC, LOGPIXELSX);
	long lLogPixelsY = ::GetDeviceCaps (hDC, LOGPIXELSY);
	::ReleaseDC (this->GetSafeHwnd (), hDC);

	int nRow, nCol;
	this->PointToCell (point, &nRow, &nCol, lLogPixelsX, lLogPixelsY);
	int nRowBorder, nColBorder;
	this->PointToBorder (point, &nRowBorder, &nColBorder, lLogPixelsX, lLogPixelsY);
	
	// s̕ύX
	if (nRowBorder >= 0 && nCol == -1 && !IsRowHeightFixed ()) {
		if (IsTextEditing ()) {
			EndTextEditingOK ();
		}
		SetCapture ();
		m_nMouseMode = TEXTGRIDCTRL_MOUSEMODEROWHEIGHTCHANGE;
		m_nMouseDownRowHeight = GetRowHeight (nRowBorder);
	}
	// 񍂂̕ύX
	else if (nColBorder >= 0 && nRow == -1 && !IsColWidthFixed ()) {
		if (IsTextEditing ()) {
			EndTextEditingOK ();
		}
		SetCapture ();
		m_nMouseMode = TEXTGRIDCTRL_MOUSEMODECOLWIDTHCHANGE;
		m_nMouseDownColWidth = GetColWidth (nColBorder);
	}
	// ZI
	else if (0 <= nRow && nRow < m_nNumRows && 0 <= nCol && nCol < m_nNumCols) {
		if (IsTextEditing ()) {
			EndTextEditingOK ();
		}
		if (nFlags & MK_SHIFT) {
			SelectArea (m_nCurRow, nRow, m_nCurCol, nCol);
		}
		else {
			SetCurCell (nRow, nCol, lLogPixelsX, lLogPixelsY);
			SelectCell (nRow, nCol);
		}
		Invalidate ();
		SetCapture ();
		m_nMouseMode = TEXTGRIDCTRL_MOUSEMODECELLSELECT;
	}
	// sI
	else if (nCol == -1 && 0 <= nRow && nRow < m_nNumRows) {
		if (IsTextEditing ()) {
			EndTextEditingOK ();
		}
		if (nFlags & MK_SHIFT) {
			SelectRow (m_nCurRow, nRow);
		}
		else {
			SetCurCell (nRow, m_nVisibleLeftCol, lLogPixelsX, lLogPixelsY);
			SelectRow (nRow, nRow);
		}
		Invalidate ();
		SetCapture ();
		m_nMouseMode = TEXTGRIDCTRL_MOUSEMODEROWSELECT;
	}
	// I
	else if (nRow == -1 && 0 <= nCol && nCol < m_nNumCols) {		
		if (IsTextEditing ()) {
			EndTextEditingOK ();
		}
		if (nFlags & MK_SHIFT) {
			SelectCol (m_nCurCol, nCol);
		}
		else {
			SetCurCell (m_nVisibleTopRow, nCol, lLogPixelsX, lLogPixelsY);
			SelectCol (nCol, nCol);
		}
		Invalidate ();
		SetCapture ();
		m_nMouseMode = TEXTGRIDCTRL_MOUSEMODECOLSELECT;
	}
	// S̑I
	else if (nRow == -1 && nCol == -1) {
		if (IsTextEditing ()) {
			EndTextEditingOK ();
		}
		SetCurCell (m_nVisibleTopRow, m_nVisibleLeftCol, lLogPixelsX, lLogPixelsY);
		SelectArea (0, m_nNumRows - 1, 0, m_nNumCols - 1);
		Invalidate ();
	}
	// }EXJ[\`̕ύX
	HCURSOR hCursor = NULL;
	if (m_nMouseMode == TEXTGRIDCTRL_MOUSEMODEROWHEIGHTCHANGE) {
		VERIFY (hCursor = ::LoadCursor (NULL, IDC_SIZENS));
	}
	else if (m_nMouseMode == TEXTGRIDCTRL_MOUSEMODECOLWIDTHCHANGE) {
		VERIFY (hCursor = ::LoadCursor (NULL, IDC_SIZEWE));
	}
	else if (nCol >= m_nNumCols || nRow >= m_nNumRows) {
		VERIFY (hCursor = ::LoadCursor (NULL, IDC_NO));
	}
	else {
		VERIFY (hCursor = ::LoadCursor (NULL, IDC_ARROW));
	}
	::SetCursor (hCursor);
	m_ptMouseDown = point;
	m_ptMouseMove = point;
	m_nMouseDownRow = nRow;
	m_nMouseDownCol = nCol;
	m_nMouseDownRowBorder = nRowBorder;
	m_nMouseDownColBorder = nColBorder;
}

// }EXE{^
void CTextGridCtrl::OnRButtonDown (UINT nFlags, CPoint point) {
	this->SetFocus ();

	// ʂdpi擾
	HDC hDC = ::GetDC (this->GetSafeHwnd ());
	long lLogPixelsX = ::GetDeviceCaps (hDC, LOGPIXELSX);
	long lLogPixelsY = ::GetDeviceCaps (hDC, LOGPIXELSY);
	::ReleaseDC (this->GetSafeHwnd (), hDC);

	int nRow, nCol;
	this->PointToCell (point, &nRow, &nCol, lLogPixelsX, lLogPixelsY);
	// Z̈
	if (0 <= nRow && nRow < m_nNumRows && 0 <= nCol && nCol < m_nNumCols) {
		if (IsTextEditing ()) {
			EndTextEditingOK ();
		}
		// I͈͊OENbNꂽ
		if (nRow < m_nSelectedTopRow || nRow > m_nSelectedBottomRow ||
			nCol < m_nSelectedLeftCol || nCol > m_nSelectedRightCol) {
			SetCurCell (nRow, nCol, lLogPixelsX, lLogPixelsY);
			SelectCell (nRow, nCol);
			Invalidate ();
			m_nMouseMode = TEXTGRIDCTRL_MOUSEMODENONE;
		}
		CPoint ptScreen (point);
		ClientToScreen (&ptScreen);
		m_theContextMenu.TrackPopupMenu (TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON,
			ptScreen.x, ptScreen.y, this);
	}
	// s̈
	else if (nCol < 0 && 0 <= nRow && nRow < m_nNumRows) {
		if (IsTextEditing ()) {
			EndTextEditingOK ();
		}
		// I͈͊OENbNꂽ
		if (IsSelectedRow (nRow) == FALSE) {
			SetCurCell (nRow, m_nVisibleLeftCol, lLogPixelsX, lLogPixelsY);
			SelectRow (nRow, nRow);
			Invalidate ();
			m_nMouseMode = TEXTGRIDCTRL_MOUSEMODENONE;
		}
		CPoint ptScreen (point);
		ClientToScreen (&ptScreen);
		m_theContextMenu.TrackPopupMenu (TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON,
			ptScreen.x, ptScreen.y, this);
	}
	// ̈
	else if (nRow < 0 && 0 <= nCol && nCol < m_nNumCols) {		
		if (IsTextEditing ()) {
			EndTextEditingOK ();
		}
		// I͈͊OENbNꂽ
		if (IsSelectedCol (nCol) == FALSE) {
			SetCurCell (m_nVisibleTopRow, nCol, lLogPixelsX, lLogPixelsY);
			SelectCol (nCol, nCol);
			Invalidate ();
			m_nMouseMode = TEXTGRIDCTRL_MOUSEMODENONE;
		}
		CPoint ptScreen (point);
		ClientToScreen (&ptScreen);
		m_theContextMenu.TrackPopupMenu (TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON,
			ptScreen.x, ptScreen.y, this);
	}
	// s
	else if (nRow < 0 && nCol < 0) {
		if (IsTextEditing ()) {
			EndTextEditingOK ();
		}
		SetCurCell (m_nVisibleTopRow, m_nVisibleLeftCol, lLogPixelsX, lLogPixelsY);
		SelectArea (0, m_nNumRows - 1, 0, m_nNumCols - 1);
		Invalidate ();
		m_nMouseMode = TEXTGRIDCTRL_MOUSEMODENONE;
		CPoint ptScreen (point);
		ClientToScreen (&ptScreen);
		m_theContextMenu.TrackPopupMenu (TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON,
			ptScreen.x, ptScreen.y, this);
	}
	m_ptMouseDown = point;
	m_ptMouseMove = point;
}



// }EX[u
void CTextGridCtrl::OnMouseMove (UINT nFlags, CPoint point) {
	// ʂdpi擾
	HDC hDC = ::GetDC (this->GetSafeHwnd ());
	long lLogPixelsX = ::GetDeviceCaps (hDC, LOGPIXELSX);
	long lLogPixelsY = ::GetDeviceCaps (hDC, LOGPIXELSY);
	::ReleaseDC (this->GetSafeHwnd (), hDC);

	CRect rcClient;
	GetClientRect (&rcClient);
	int nRow, nCol;
	this->PointToCell (point, &nRow, &nCol, lLogPixelsX, lLogPixelsY);
	int nRowBorder, nColBorder;
	this->PointToBorder (point, &nRowBorder, &nColBorder, lLogPixelsX, lLogPixelsY);
	// ALv`[̏
	if (GetCapture () != this) {
		// }EXJ[\`̕ύX
		HCURSOR hCursor = NULL;
		if (nRowBorder >= 0 && nCol == -1 && !IsRowHeightFixed ()) {
			VERIFY (hCursor = ::LoadCursor (NULL, IDC_SIZENS));
		}
		else if (nColBorder >= 0 && nRow == -1 && !IsColWidthFixed ()) {
			VERIFY (hCursor = ::LoadCursor (NULL, IDC_SIZEWE));
		}
		else if (nCol >= m_nNumCols || nRow >= m_nNumRows) {
			VERIFY (hCursor = ::LoadCursor (NULL, IDC_NO));
		}
		else {
			VERIFY (hCursor = ::LoadCursor (NULL, IDC_ARROW));
		}
		::SetCursor (hCursor);
	}
	// Lv`[̏
	if (GetCapture () == this && point != m_ptMouseDown) {
		// }EXJ[\`̕ύX
		HCURSOR hCursor = NULL;
		if (m_nMouseMode == TEXTGRIDCTRL_MOUSEMODEROWHEIGHTCHANGE) {
			VERIFY (hCursor = ::LoadCursor (NULL, IDC_SIZENS));
		}
		else if (m_nMouseMode == TEXTGRIDCTRL_MOUSEMODECOLWIDTHCHANGE) {
			VERIFY (hCursor = ::LoadCursor (NULL, IDC_SIZEWE));
		}
		else {
			VERIFY (hCursor = ::LoadCursor (NULL, IDC_ARROW));
		}
		::SetCursor (hCursor);
		// InO
		int nRow2 = TEXTGRIDCTRL_RANGE 
			(GetVisibleTopRow () - 1, nRow, GetVisibleBottomRow (lLogPixelsX, lLogPixelsY) + 1);
		int nCol2 =	TEXTGRIDCTRL_RANGE 
			(GetVisibleLeftCol () - 1, nCol, GetVisibleRightCol (lLogPixelsX, lLogPixelsY) + 1);				
		int nRow3 = TEXTGRIDCTRL_RANGE (0, nRow2, m_nNumRows - 1);
		int nCol3 = TEXTGRIDCTRL_RANGE (0, nCol2, m_nNumCols - 1);		
		int nOldSelectedTopRow = m_nSelectedTopRow;
		int nOldSelectedBottomRow = m_nSelectedBottomRow;
		int nOldSelectedLeftCol = m_nSelectedLeftCol;
		int nOldSelectedRightCol = m_nSelectedRightCol;
		// ZI
		if (m_nMouseMode == TEXTGRIDCTRL_MOUSEMODECELLSELECT) {
			SelectArea (m_nCurRow, nRow3, m_nCurCol, nCol3);
			AutoScrolltoShowCell (nRow3, nCol3, lLogPixelsX, lLogPixelsY);
			if (nOldSelectedTopRow != m_nSelectedTopRow ||
				nOldSelectedBottomRow != m_nSelectedBottomRow ||
				nOldSelectedLeftCol != m_nSelectedLeftCol ||
				nOldSelectedRightCol != m_nSelectedRightCol) {
				Invalidate ();
			}
		}
		// sI
		else if (m_nMouseMode == TEXTGRIDCTRL_MOUSEMODEROWSELECT) {
			SelectRow (m_nCurRow, nRow3);
			AutoScrolltoShowRow (nRow3, lLogPixelsX, lLogPixelsY);
			if (nOldSelectedTopRow != m_nSelectedTopRow ||
				nOldSelectedBottomRow != m_nSelectedBottomRow) {
				Invalidate ();
			}
		}
		// I
		else if (m_nMouseMode == TEXTGRIDCTRL_MOUSEMODECOLSELECT) {
			SelectCol (m_nCurCol, nCol3);
			AutoScrolltoShowCol (nCol3, lLogPixelsX, lLogPixelsY);
			if (nOldSelectedLeftCol != m_nSelectedLeftCol ||
				nOldSelectedRightCol != m_nSelectedRightCol) {
				Invalidate ();
			}
		}
		// s̕ύX
		else if (m_nMouseMode == TEXTGRIDCTRL_MOUSEMODEROWHEIGHTCHANGE) {
			int nDeltaY = (point.y - m_ptMouseDown.y) * 96 / lLogPixelsY;
			if (0 <= m_nMouseDownRowBorder && m_nMouseDownRowBorder < GetNumRows ()) {
				int nHeight = GetRowHeight (m_nMouseDownRowBorder);
				nHeight = TEXTGRIDCTRL_RANGE 
					(1, m_nMouseDownRowHeight + nDeltaY, rcClient.Height () - m_nTitleHeight);
				if (IsSelectedRow (m_nMouseDownRowBorder)) {
					for (int i = m_nSelectedTopRow; i <= m_nSelectedBottomRow; i++) {
						SetRowHeight (i, nHeight);
					}
				}
				else {
					SetRowHeight (m_nMouseDownRowBorder, nHeight);
				}
				Invalidate ();
			}
		}
		// 񕝂̕ύX
		else if (m_nMouseMode == TEXTGRIDCTRL_MOUSEMODECOLWIDTHCHANGE) {
			int nDeltaX = (point.x - m_ptMouseDown.x) * 96 / lLogPixelsX;
			if (0 <= m_nMouseDownColBorder && m_nMouseDownColBorder < GetNumCols ()) {
				int nWidth = GetColWidth (m_nMouseDownColBorder);
				nWidth = TEXTGRIDCTRL_RANGE 
					(1, m_nMouseDownColWidth + nDeltaX, rcClient.Width () - m_nTitleWidth);
				if (IsSelectedCol (m_nMouseDownColBorder)) {
					for (int j = m_nSelectedLeftCol; j <= m_nSelectedRightCol; j++) {
						SetColWidth (j, nWidth);
					}
				}
				else {
					SetColWidth (m_nMouseDownColBorder, nWidth);
				}
				Invalidate ();
			}
		}
	}
	m_ptMouseMove = point;
}

// }EX{^グ
void CTextGridCtrl::OnLButtonUp (UINT nFlags, CPoint point) {
	// ʂdpi擾
	HDC hDC = ::GetDC (this->GetSafeHwnd ());
	long lLogPixelsX = ::GetDeviceCaps (hDC, LOGPIXELSX);
	long lLogPixelsY = ::GetDeviceCaps (hDC, LOGPIXELSY);
	::ReleaseDC (this->GetSafeHwnd (), hDC);

	int nRow, nCol;
	this->PointToCell (point, &nRow, &nCol, lLogPixelsX, lLogPixelsY);
	if (GetCapture () == this) {
		VERIFY (ReleaseCapture ());
	}
	// }EXJ[\`̕ύX
	HCURSOR hCursor = NULL;
	if (m_nMouseMode == TEXTGRIDCTRL_MOUSEMODEROWHEIGHTCHANGE) {
		VERIFY (hCursor = ::LoadCursor (NULL, IDC_SIZENS));
	}
	else if (m_nMouseMode == TEXTGRIDCTRL_MOUSEMODECOLWIDTHCHANGE) {
		VERIFY (hCursor = ::LoadCursor (NULL, IDC_SIZEWE));
	}
	else if (nCol >= m_nNumCols || nRow >= m_nNumRows) {
		VERIFY (hCursor = ::LoadCursor (NULL, IDC_NO));
	}
	else {
		VERIFY (hCursor = ::LoadCursor (NULL, IDC_ARROW));
	}
	::SetCursor (hCursor);
}

// }EX{^_uNbN
void CTextGridCtrl::OnLButtonDblClk (UINT nFlags, CPoint point) {
	// ʂdpi擾
	HDC hDC = ::GetDC (this->GetSafeHwnd ());
	long lLogPixelsX = ::GetDeviceCaps (hDC, LOGPIXELSX);
	long lLogPixelsY = ::GetDeviceCaps (hDC, LOGPIXELSY);
	::ReleaseDC (this->GetSafeHwnd (), hDC);

	int nRow, nCol;
	this->PointToCell (point, &nRow, &nCol, lLogPixelsX, lLogPixelsY);
	if (0 <= nRow && nRow < m_nNumRows &&
		0 <= nCol && nCol < m_nNumCols) {
		if (IsReadOnly () == FALSE) {
			BeginTextEditingContinue ();
		}
	}
}



// L[_E
void CTextGridCtrl::OnKeyDown (UINT nChar, UINT nRepCnt, UINT nFlags) {
	// ʂdpi擾
	HDC hDC = ::GetDC (this->GetSafeHwnd ());
	long lLogPixelsX = ::GetDeviceCaps (hDC, LOGPIXELSX);
	long lLogPixelsY = ::GetDeviceCaps (hDC, LOGPIXELSY);
	::ReleaseDC (this->GetSafeHwnd (), hDC);

	int nVisibleRows = __max (1, (GetVisibleBottomRow (lLogPixelsX, lLogPixelsY) - GetVisibleTopRow ()));
	int nVisibleCols = __max (1, (GetVisibleRightCol (lLogPixelsX, lLogPixelsY) - GetVisibleLeftCol ()));
	switch (nChar) {
	//L[
	case VK_LEFT:
		if (IsTextEditing ()) {
			EndTextEditingOK ();
		}
		if (::GetKeyState (VK_SHIFT) < 0) {
			if (::GetKeyState (VK_CONTROL) < 0) {
				m_nKeyMoveCol = 0;
			}
			else {
				m_nKeyMoveCol = TEXTGRIDCTRL_RANGE (0, m_nKeyMoveCol - 1, m_nNumCols - 1);
			}
			SelectArea (m_nSelectedTopRow, m_nSelectedBottomRow, m_nKeyMoveCol, m_nCurCol);
			AutoScrolltoShowCol (m_nKeyMoveCol, lLogPixelsX, lLogPixelsY);
		}
		else {
			if (::GetKeyState (VK_CONTROL) < 0) {
				SetCurCell (m_nCurRow, 0, lLogPixelsX, lLogPixelsY);
			}
			else {
				SetCurCell (m_nCurRow, TEXTGRIDCTRL_RANGE (0, m_nCurCol - 1, m_nNumCols - 1), lLogPixelsX, lLogPixelsY);
			}
			SelectCell (m_nCurRow, m_nCurCol);
		}
		Invalidate ();
		break;
	// L[
	case VK_UP:
		if (IsTextEditing ()) {
			EndTextEditingOK ();
		}
		if (::GetKeyState (VK_SHIFT) < 0) {
			if (::GetKeyState (VK_CONTROL) < 0) {
				m_nKeyMoveRow = 0;
			}
			else {
				m_nKeyMoveRow = TEXTGRIDCTRL_RANGE (0, m_nKeyMoveRow - 1, m_nNumRows - 1);
			}
			SelectArea (m_nCurRow, m_nKeyMoveRow, m_nSelectedLeftCol, m_nSelectedRightCol);
			AutoScrolltoShowRow (m_nKeyMoveRow, lLogPixelsX, lLogPixelsY);
		}
		else {
			if (::GetKeyState (VK_CONTROL) < 0) {
				SetCurCell (0, m_nCurCol, lLogPixelsX, lLogPixelsY);
			}
			else {
				SetCurCell (TEXTGRIDCTRL_RANGE (0, m_nCurRow - 1, m_nNumRows - 1), m_nCurCol, lLogPixelsX, lLogPixelsY);
			}
			SelectCell (m_nCurRow, m_nCurCol);
		}
		Invalidate ();
		break;
	// EL[
	case VK_RIGHT:
		if (IsTextEditing ()) {
			EndTextEditingOK ();
		}
		if (::GetKeyState (VK_SHIFT) < 0) {
			if (::GetKeyState (VK_CONTROL) < 0) {
				m_nKeyMoveCol = m_nNumCols - 1;	
			}
			else {
				m_nKeyMoveCol = TEXTGRIDCTRL_RANGE (0, m_nKeyMoveCol + 1, m_nNumCols - 1);
			}
			SelectArea (m_nSelectedTopRow, m_nSelectedBottomRow, m_nKeyMoveCol, m_nCurCol);
			AutoScrolltoShowCol (m_nKeyMoveCol, lLogPixelsX, lLogPixelsY);
		}
		else {
			if (::GetKeyState (VK_CONTROL) < 0) {
				SetCurCell (m_nCurRow, m_nNumCols - 1, lLogPixelsX, lLogPixelsY);
			}
			else {
				SetCurCell (m_nCurRow, TEXTGRIDCTRL_RANGE (0, m_nCurCol + 1, m_nNumCols - 1), lLogPixelsX, lLogPixelsY);
			}
			SelectCell (m_nCurRow, m_nCurCol);
		}
		Invalidate ();
		break;
	// L[
	case VK_DOWN:
		if (IsTextEditing ()) {
			EndTextEditingOK ();
		}
		if (::GetKeyState (VK_SHIFT) < 0) {
			if (::GetKeyState (VK_CONTROL) < 0) {
				m_nKeyMoveRow = m_nNumRows - 1;
			}
			else {
				m_nKeyMoveRow = TEXTGRIDCTRL_RANGE (0, m_nKeyMoveRow + 1, m_nNumRows - 1);
			}
			SelectArea (m_nCurRow, m_nKeyMoveRow, m_nSelectedLeftCol, m_nSelectedRightCol);
			AutoScrolltoShowRow (m_nKeyMoveRow, lLogPixelsX, lLogPixelsY);
		}
		else {
			if (::GetKeyState (VK_CONTROL) < 0) {
				SetCurCell (m_nNumRows - 1, m_nCurCol, lLogPixelsX, lLogPixelsY);
			}
			else {
				SetCurCell (TEXTGRIDCTRL_RANGE (0, m_nCurRow + 1, m_nNumRows - 1), m_nCurCol, lLogPixelsX, lLogPixelsY);
			}
			SelectCell (m_nCurRow, m_nCurCol);
		}
		Invalidate ();
		break;
	// HomeL[
	case VK_HOME:
		if (IsTextEditing ()) {
			EndTextEditingOK ();
		}
		if (::GetKeyState (VK_SHIFT) < 0) {
			m_nKeyMoveCol = TEXTGRIDCTRL_RANGE (0, m_nKeyMoveCol - nVisibleCols, m_nNumCols - 1);
			SelectArea (m_nSelectedTopRow, m_nSelectedBottomRow, m_nKeyMoveCol, m_nCurCol);
			AutoScrolltoShowCol (m_nKeyMoveCol, lLogPixelsX, lLogPixelsY);
		}
		else {
			SetCurCell (m_nCurRow, TEXTGRIDCTRL_RANGE (0, m_nCurCol - nVisibleCols, m_nNumCols - 1), lLogPixelsX, lLogPixelsY);
			SelectCell (m_nCurRow, m_nCurCol);
		}
		Invalidate ();
		break;
	// PageUpL[
	case VK_PRIOR:
		if (IsTextEditing ()) {
			EndTextEditingOK ();
		}
		if (::GetKeyState (VK_SHIFT) < 0) {
			m_nKeyMoveRow = TEXTGRIDCTRL_RANGE (0, m_nKeyMoveRow - nVisibleRows, m_nNumRows - 1);
			SelectArea (m_nCurRow, m_nKeyMoveRow, m_nSelectedLeftCol, m_nSelectedRightCol);
			AutoScrolltoShowRow (m_nKeyMoveRow, lLogPixelsX, lLogPixelsY);
		}
		else {
			SetCurCell (TEXTGRIDCTRL_RANGE (0, m_nCurRow - nVisibleRows, m_nNumRows - 1), m_nCurCol, lLogPixelsX, lLogPixelsY);
			SelectCell (m_nCurRow, m_nCurCol);
		}
		Invalidate ();
		break;
	// EndL[
	case VK_END:
		if (IsTextEditing ()) {
			EndTextEditingOK ();
		}
		if (::GetKeyState (VK_SHIFT) < 0) {
			m_nKeyMoveCol = TEXTGRIDCTRL_RANGE (0, m_nKeyMoveCol + nVisibleCols, m_nNumCols - 1);
			SelectArea (m_nSelectedTopRow, m_nSelectedBottomRow, m_nKeyMoveCol, m_nCurCol);
			AutoScrolltoShowCol (m_nKeyMoveCol, lLogPixelsX, lLogPixelsY);
		}
		else {
			SetCurCell (m_nCurRow, TEXTGRIDCTRL_RANGE (0, m_nCurCol + nVisibleCols, m_nNumCols - 1), lLogPixelsX, lLogPixelsY);
			SelectCell (m_nCurRow, m_nCurCol);
		}
		Invalidate ();
		break;
	// PageDownL[
	case VK_NEXT:
		if (IsTextEditing ()) {
			EndTextEditingOK ();
		}
		if (::GetKeyState (VK_SHIFT) < 0) {
			m_nKeyMoveRow = TEXTGRIDCTRL_RANGE (0, m_nKeyMoveRow + nVisibleRows, m_nNumRows - 1);
			SelectArea (m_nCurRow, m_nKeyMoveRow, m_nSelectedLeftCol, m_nSelectedRightCol);
			AutoScrolltoShowRow (m_nKeyMoveRow, lLogPixelsX, lLogPixelsY);
		}
		else {
			SetCurCell (TEXTGRIDCTRL_RANGE (0, m_nCurRow + nVisibleRows, m_nNumRows - 1), m_nCurCol, lLogPixelsX, lLogPixelsY);
			SelectCell (m_nCurRow, m_nCurCol);
		}
		Invalidate ();
		break;
	// s(Enter)L[
	case VK_RETURN:
		// eLXgҏWłȂꍇ
		if (IsTextEditing () == FALSE && IsReadOnly () == FALSE) {
			BeginTextEditingContinue ();
		}
		// eLXgҏW̏ꍇ(CTextGridEditNXSendMessageB)
		else {
			EndTextEditingOK ();
			Invalidate ();
		}
		break;
	// GXP[v(Esc)L[(CTextGridEditNXSendMessageB)
	case VK_ESCAPE:
		EndTextEditingCancel ();
		Invalidate ();
		break;
	// DeleteL[
	case VK_DELETE:
		Delete ();
		Invalidate ();
		break;
	}
	CWnd::OnKeyDown (nChar, nRepCnt, nFlags);
}


// ͎
void CTextGridCtrl::OnChar (UINT nChar, UINT nRepCnt, UINT nFlags) {
	// ʂdpi擾
	HDC hDC = ::GetDC (this->GetSafeHwnd ());
	long lLogPixelsX = ::GetDeviceCaps (hDC, LOGPIXELSX);
	long lLogPixelsY = ::GetDeviceCaps (hDC, LOGPIXELSY);
	::ReleaseDC (this->GetSafeHwnd (), hDC);

	if (IsReadOnly () == FALSE) {
		if (32 <= nChar) {
			MoveTextBox (lLogPixelsX, lLogPixelsY);
			BeginTextEditing ();
			//m_theTextBox.SendMessage (WM_CHAR, nChar, (nRepCnt << 16) | nFlags);
			m_theTextBox.SendMessage (WM_CHAR, nChar, (nFlags << 16) | (nRepCnt & 0x00FF));
		}
	}
}

// ͎
LRESULT CTextGridCtrl::OnImeStartComposition (WPARAM wParam, LPARAM lParam) {
	// ʂdpi擾
	HDC hDC = ::GetDC (this->GetSafeHwnd ());
	long lLogPixelsX = ::GetDeviceCaps (hDC, LOGPIXELSX);
	long lLogPixelsY = ::GetDeviceCaps (hDC, LOGPIXELSY);
	::ReleaseDC (this->GetSafeHwnd (), hDC);

	if (IsReadOnly () == FALSE) {
		MoveTextBox (lLogPixelsX, lLogPixelsY);
		BeginTextEditing ();
		m_theTextBox.SendMessage (WM_IME_STARTCOMPOSITION, wParam, lParam);
	}
	return 1;
}

// ؂
void CTextGridCtrl::OnContextCut () {
	this->Cut ();
	Invalidate ();
}

// ؂
void CTextGridCtrl::OnUpdateContextCut (CCmdUI* pCmdUI) {
	pCmdUI->Enable (IsReadOnly () == FALSE);
}


// Rs[
void CTextGridCtrl::OnContextCopy () {
	this->Copy ();
	Invalidate ();
}

// Rs[
void CTextGridCtrl::OnUpdateContextCopy (CCmdUI* pCmdUI) {
}

// \t
void CTextGridCtrl::OnContextPaste () {
	this->Paste ();
	Invalidate ();
}

// \t
void CTextGridCtrl::OnUpdateContextPaste (CCmdUI* pCmdUI) {
	pCmdUI->Enable (IsReadOnly () == FALSE);
}

// 폜
void CTextGridCtrl::OnContextDelete () {
	this->Delete ();
	Invalidate ();
}
// 폜
void CTextGridCtrl::OnUpdateContextDelete (CCmdUI* pCmdUI) {
	pCmdUI->Enable (IsReadOnly () == FALSE);
}
